# DifferentialAlgebra

DifferentialAlgebra a computer algebra software for simplifying systems of polynomial differential equations.

The DifferentialAlgebra project aims at providing BLAD, a C library dedicated to Ritt and Kolchin differential algebra, and BMI, a library providing interface packages for various scientific computing software such as Maple, Sagemath, Python / sympy ...

The BLAD and BMI libraries have been integrated in the Maple DifferentialAlgebra package since 2008.
They are available through the Python DifferentialAlgebra package since Dec. 2023.

After somewhat like 10 years of inactivity, a major revision has been undertaken in 2023. 
It led to DifferentialAlgebra 4

# Dependencies

The BLAD libraries rely either on GMP or on an embedded version of mini-gmp.
The embedded version of mini-gmp is located in the BLAD/ba0 sublibrary.
The modifications brought to its source code are precisely documented.

By default, the Python package relies on the embedded version of mini-gmp but it can also be built and installed in order to use GMP.
The Python package depends on sympy.

# Installing the Python package without building it

python -m pip install DifferentialAlgebra

Note: the above command is currently only working for Linux/amd64 platforms.
It is reported to work on MacOS platforms also.

# Building the project from the git repository

The commands listed below work on a Linux machine, to generate the Python version of DifferentialAlgebra built over sympy

## 0. Build configure files

A C compiler is needed as well as the autotools

cd blad  
./tools/autogen  
cd ../bmi  
../blad/tools/autogen

## 1. Build and install blad

cd ..  
mkdir blad-build  
cd blad-build  
../blad/tools/blad_configure_for_install  
make  
make check  
make pdf  
make install

## 2. Build the DifferentialAlgebra packaging directory

Python >= 3.8 is needed as well as Cython 3 (for Python >= 3.12)

cd ..  
mkdir bmi-build-sympy  
cd bmi-build-sympy  
../bmi/tools/bmi_configure_for_sympy  
make  
make check  
make pdf  
make install

## 3. Build and install the DifferentialAlgebra Python package

cd ../bmi-install-sympy/packaging  
python3 setup.py build  
python3 -m pip install . --upgrade
