#include "ba0.h"

int
main (
    void)
{
  struct ba0_mark M;
  ba0_mpz_t p;
  char buffer[128];
  bool b;
// In this example, q and T are processed by the gargabe collector
// Thus these variables MUST be pointers and not structures in the
// process stack
  ba0__mpq_struct *q;
  struct ba0_tableof_mpz *T;

  ba0_restart (0, 0);
  ba0_mpz_init_set_si (p, 888);
// Mark M is set after p
  ba0_record (&M);
// Wasted memory
  ba0_new_mpz ();
// q is assigned some rational number
  q = ba0_new_mpq ();
  ba0_mpq_set_si_si (q, 22, 7);
// T is assigned a table of two numbers. 
// The two entries are shared dynamically allocated areas
  T = (struct ba0_tableof_mpz *) ba0_new_table ();
  ba0_sscanf2 ("[421, 317]", "%t[%z]", T);
  T->tab[0] = T->tab[1];
// T is resized to get a third entry. The former field T->tab is lost
  ba0_realloc2_table ((struct ba0_table *) T, 3,
      (ba0_new_function *) & ba0_new_mpz);
  ba0_mpz_set_si (T->tab[2], 512);
  T->size = 3;
// Any area which is not part of q or of T is recovered. 
// T and q are moved just above M. Formerly shared areas keep being shared.
// The order in memory is preserved: q, initialized first, is located at M.
  ba0_garbage ("%q%t[%z]", &M, &q, &T);
  b = T->tab[0] == T->tab[1] && M.address == (void *) q;
  ba0_sprintf (buffer, "%z, %q, %t[%z]", p, q, T);
  b = b && strcmp (buffer, "888, 22/7, [317, 317, 512]") == 0;
  ba0_terminate (ba0_init_level);
  return b ? 0 : 1;
}
