#include "ba0.h"

static bool
comp (
    void *a,
    void *b)
{
  ba0__mpz_struct *p = a;
  ba0__mpz_struct *q = b;
  ba0_mpz_t d;
  struct ba0_mark M;
  bool res;
  ba0_record (&M);
  ba0_mpz_init (d);
  ba0_mpz_sub (d, q, p);
  res = ba0_mpz_is_negative (d);
  ba0_restore (&M);
  return res;
}

int
main (
    void)
{
  struct ba0_mark M;
  ba0__mpz_struct *number;
  struct ba0_list *L;
  ba0_int_p first;
  char buffer[1024];
  char ref_buff[1024];
  bool ok;
  int n;

  ba0_get_settings_stack (&first, 0, 0, 0, 0);
  ba0_restart (0, 0);
  n = 27;
  L = (struct ba0_list *) 0;
  while (n != 1)
    {
      if (n == 445)
        ba0_record (&M);
      ba0_alloc (3 * first / 100);
      number = (ba0__mpz_struct *) ba0_alloc (sizeof (ba0__mpz_struct));
      ba0_mpz_init (number);
      ba0_mpz_set_ui (number, n);
      L = ba0_cons_list (number, L);
      if (n % 2 == 0)
        n /= 2;
      else
        n = 3 * n + 1;
    }
  L = ba0_sort_list (L, &comp);
  ba0_garbage ("%l[%z]", &M, &L);
  ba0_sprintf (buffer, "%l[%z]", L);
  sprintf (ref_buff, "%s%s",
      "[9232, 7288, 6154, 4858, 4616, 4102, 3644, 3238, 3077, 2734, 2429, 2308, 2158, 2051, 1822, 1780, 1732, 1619, 1438, 1367, 1336, 1300, 1276, 1186, 1154, 1132, 1079, 976, 958, 911, 890, 866, 850, 790, 754, 719, 700, 668, 650, 638, 593, 577, 566, 526, 502, 488, 484, 479,",
      " 466, 445, 433, 425, 412, 395, 377, 364, 350, 334, 325, 322, 319, 310, 283, 274, 263, 251, 244, 242, 233, 214, 206, 184, 182, 175, 167, 161, 160, 155, 142, 137, 124, 122, 121, 107, 106, 103, 94, 92, 91, 82, 80, 71, 70, 62, 61, 53, 47, 46, 41, 40, 35, 31, 27, 23, 20, 16, 10, 8, 5, 4, 2]");
  ok = strcmp (buffer, ref_buff) == 0;

  ba0_terminate (ba0_init_level);
  return ok ? 0 : 1;
}
