#include "ba0.h"

int
main (
    void)
{
  struct ba0_tableof_interval_mpq F;
  struct ba0_interval_mpq A, B, C;
  struct ba0_mark M;
  bool b;
  char buffer[1024];

  ba0_restart (0, 0);
  ba0_record (&M);

  ba0_init_table ((struct ba0_table *) &F);
  ba0_init_interval_mpq (&A);
  ba0_init_interval_mpq (&B);
  ba0_init_interval_mpq (&C);

  ba0_sscanf2 ("[1,2], [1,7]", "%qi, %qi", &A, &B);
  ba0_add_interval_mpq (&C, &A, &B);
  ba0_sprintf (buffer, "%qi", &C);
  b = strcmp (buffer, "[2, 9]") == 0;

  ba0_sub_interval_mpq (&C, &A, &B);
  ba0_sprintf (buffer, "%qi", &C);
  b = b && strcmp (buffer, "[-6, 1]") == 0;

  ba0_mul_interval_mpq (&C, &A, &B);
  ba0_sprintf (buffer, "%qi", &C);
  b = b && strcmp (buffer, "[1, 14]") == 0;

  ba0_div_interval_mpq (&F, &A, &B);
  ba0_sprintf (buffer, "%t[%qi]", &F);
  b = b && strcmp (buffer, "[[1/7, 2]]") == 0;

  ba0_sscanf2 ("[1,2], [-7,-1]", "%qi, %qi", &A, &B);
  ba0_add_interval_mpq (&C, &A, &B);
  ba0_sprintf (buffer, "%qi", &C);
  b = b && strcmp (buffer, "[-6, 1]") == 0;

  ba0_sub_interval_mpq (&C, &A, &B);
  ba0_sprintf (buffer, "%qi", &C);
  b = b && strcmp (buffer, "[2, 9]") == 0;

  ba0_mul_interval_mpq (&C, &A, &B);
  ba0_sprintf (buffer, "%qi", &C);
  b = b && strcmp (buffer, "[-14, -1]") == 0;

  ba0_div_interval_mpq (&F, &A, &B);
  ba0_sprintf (buffer, "%t[%qi]", &F);
  b = b && strcmp (buffer, "[[-2, -1/7]]") == 0;

  ba0_sscanf2 ("[1,2], [-7,1]", "%qi, %qi", &A, &B);
  ba0_add_interval_mpq (&C, &A, &B);
  ba0_sprintf (buffer, "%qi", &C);
  b = b && strcmp (buffer, "[-6, 3]") == 0;

  ba0_sub_interval_mpq (&C, &A, &B);
  ba0_sprintf (buffer, "%qi", &C);
  b = b && strcmp (buffer, "[0, 9]") == 0;

  ba0_mul_interval_mpq (&C, &A, &B);
  ba0_sprintf (buffer, "%qi", &C);
  b = b && strcmp (buffer, "[-14, 2]") == 0;
/*
 * Not yet implemented
    ba0_div_interval_mpq (&F, &A, &B);
    ba0_sprintf (buffer, "%t[%qi]", &F);
    b = b && strcmp (buffer, "[[-inf, -1/7], [1, inf]]") == 0;
 */
  ba0_terminate (ba0_init_level);
  return b ? 0 : 1;
}
