#include "ba0.h"

static double
invert_double (
    double z)
{
  struct ba0_mark M;

  ba0_record (&M);
// simulate some temporary memory allocation
  ba0_alloc (10);
  if (z == 0.)
    BA0_RAISE_EXCEPTION (BA0_ERRIVZ);
// the temporary area is freed only if no exception was raised
  ba0_restore (&M);
  return 1. / z;
}

int
main (
    void)
{
  struct ba0_arrayof_double T;
  struct ba0_mark M;
  bool b = true;

  ba0_restart (0, 0);
  ba0_init_array ((struct ba0_array *) &T);
  ba0_sscanf2 ("[3., 0., -5]", "%a[%le]", &T);
  ba0_record (&M);
  for (int i = 0; i < T.size; i++)
    {
      BA0_TRY
      {
        double d;
        d = invert_double (T.tab[i]);
        ba0_printf ("the inverse of %le is: %le\n", &T.tab[i], &d);
// Check that the call is successful for i = 0 or 2
        b = b && (i == 0 || i == 2);
      }
      BA0_CATCH
      {
        if (ba0_global.exception.raised != BA0_ERRIVZ)
          BA0_RE_RAISE_EXCEPTION;
        ba0_printf ("%le has no inverse\n", &T.tab[i]);
// Check that exception BA0_ERRIVZ was raised for i == 1
        b = b && (i == 1);
      }
      BA0_ENDTRY;
    }
// Check that no memory was lost, even at loop i == 1
  b = b && M.address == M.stack->free.address;
  ba0_terminate (ba0_init_level);
  return b ? 0 : 1;
}
