#include "bad.h"

/*
 * Date: Fri, 02 Nov 2012 18:34:17 +0000
 * From: Markus Rosenkranz <M.Rosenkranz@kent.ac.uk>
 *
 * Dear Francois,
 * 
 * When preparing an example for the second exercise sheet, I ran into the
 * following problem that might be a bug in the package or perhaps I just
 * do not understand enough. If you have time, please have a look at that.
 * The example is taken from Buium and Cassidy's survey in the Kolchin
 * memorial volume, page 20.
 * 
 * Best wishes.
 * -- Markus.
 *
 * Indeed, there was a bug.
 */

int
main (
    void)
{
  struct bad_base_field K;
  struct bad_preparation_equation E;
  struct bad_intersectof_regchain *T;
  struct bap_tableof_polynom_mpz *eqns;
  struct bad_regchain *A;
  struct bap_polynom_mpz F;
  struct bap_polynom_mpz *ddz;
  bav_Iordering r;
  struct ba0_mark M;
  char buffer[512];
  bool b;

  bad_restart (0, 0);
  ba0_record (&M);

  bad_initialized_global.reduction.reduction_strategy =
      bad_gcd_prem_and_factor_reduction_strategy;

  ba0_sscanf2 ("ordering (derivations = [x], blocks = [y])", "%ordering", &r);

  bav_R_push_ordering (r);
  eqns = (struct bap_tableof_polynom_mpz *) ba0_new_table ();
  ba0_sscanf2 ("[y[x,x]^2+2*y[x,x]*y[x]*y^3-4*y[x]^3*y^2]", "%t[%Az]", eqns);

  T = bad_new_intersectof_regchain ();
  ba0_sscanf2 ("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])", "%intersectof_regchain", T);

  bad_init_base_field (&K);

  bad_Rosenfeld_Groebner
      (T, eqns, (struct bap_tableof_polynom_mpz *) 0, &K,
      (struct bad_regchain *)0, (struct bad_splitting_control *) 0);

  b = T->inter.size == 3;
  A = T->inter.tab[1];

  bap_init_polynom_mpz (&F);
  ba0_sscanf2 ("y[x,x]^2+2*y[x,x]*y[x]*y^3-4*y[x]^3*y^2", "%Az", &F);

  bad_init_preparation_equation (&E);
  bad_set_preparation_equation_polynom
      (&E, &F, (ba0__mpz_struct *) 0, A, &K, &ddz);
  bad_check_preparation_equation (&E);

  ba0_sprintf (buffer, "%preparation_equation", &E);
  b = b
      &&
      strcmp
      ("262144 * (y[x,x]^2 + 2*y[x,x]*y[x]*y^3 - 4*y[x]^3*y^2) = (-16384*y^10)*z1 + (16384)*z1[x]^2 + (32768*y^6)*z1^2 + (-16384*y^2)*z1^3",
      buffer) == 0;

  bav_R_pull_ordering ();
  bad_terminate (ba0_init_level);
  return b ? 0 : 1;
}
