#include "bad.h"

int
main (
    int argc,
    char **argv)
{
  struct bad_intersectof_regchain ideal;
  struct bad_regchain relations;
  struct bad_splitting_control control;
  struct bad_base_field K;
  struct bad_regchain A;
  struct bap_tableof_tableof_polynom_mpz result;
  struct bap_tableof_polynom_mpz eqns, ineqs, nulles;
  struct bap_product_mpz R, H;
  bav_Iordering r;
  struct ba0_tableof_string properties;
  struct ba0_table blks;
  struct ba0_tableof_string ders, pars;
  ba0_int_p timelimit;
  FILE *f;
  volatile bool b = true;
  char nota[64], dring[64], singsol[64];
  static char buffer[16384];
  char *computed, *expected;
/*
 * Are we able to open the file?
 */
  if (argc != 2)
    {
      fprintf (stderr, "error: missing filename on command line\n");
      return 1;
    }
  f = fopen (argv[1], "r");
  if (f == NULL)
    {
      fprintf (stderr, "unable to open: %s\n", argv[1]);
      return 1;
    }
/*
 * First read timelimit
 */
  bad_restart (0, 0);
  BA0_TRY
  {
    ba0_set_input_FILE (f);
    ba0_get_token_analex ();
    ba0_scanf ("timelimit = %d", &timelimit);
  }
  BA0_CATCH
  {
    fprintf (stderr, "missing timelimit on first line\n");
    exit (1);
  }
  BA0_ENDTRY;
  bad_terminate (ba0_init_level);
/*
 * Then restart blad with this timelimit
 */
  bad_restart (timelimit, 0);

  BA0_TRY
  {
    ba0_set_input_FILE (f);
/*
 * R = DifferentialRing (...)
 */
    ba0_init_table (&blks);
    ba0_init_table ((struct ba0_table *) &pars);
    ba0_init_table ((struct ba0_table *) &ders);

    ba0_get_token_analex ();
    ba0_scanf
        ("R = DifferentialRing (blocks = %t[%b], parameters = %t[%six], derivations = %t[%six], notation = %s)",
        &blks, &pars, &ders, nota);
/*
 * Do not bother with nota
 */
    bav_set_settings_variable (&bav_scanf_maple_all_variable, 0, 0, 0, 0);
    bav_set_settings_rank (&bav_printf_stars_rank);
/*
 * The ordering
 */
    ba0_sprintf (buffer,
        "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering",
        "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_global.parameters, &pars);
/*
 * The regchain
 */
    bad_init_regchain (&A);
    ba0_get_token_analex ();
    ba0_scanf ("A = %regchain", &A);
    ba0_sprintf (buffer, "regchain = %regchain\n", &A);
/*
 * The base field
 */
    bad_init_base_field (&K);
    ba0_get_token_analex ();
    ba0_scanf ("K = %base_field", &K);
    ba0_sprintf (buffer, "basefield = %base_field\n", &K);
/*
 * The lists of equations and inequations
 */
    ba0_init_table ((struct ba0_table *) &eqns);
    ba0_init_table ((struct ba0_table *) &ineqs);
    ba0_get_token_analex ();
    ba0_scanf ("eqns = %t[%Az]", &eqns);
    ba0_get_token_analex ();
    ba0_scanf ("ineqs = %t[%Az]", &ineqs);

    ba0_init_table ((struct ba0_table *) &nulles);
    bap_zero_derivatives_of_tableof_parameter_mpz (&nulles,
        &bav_global.parameters);
    ba0_concat_table ((struct ba0_table *) &eqns, (struct ba0_table *) &eqns,
        (struct ba0_table *) &nulles);

    ba0_sprintf (buffer, "eqns = %t[%Az]\n", &eqns);
    ba0_sprintf (buffer, "ineqs = %t[%Az]\n", &ineqs);
/*
 * properties = %t[%s]
 */
    ba0_init_table ((struct ba0_table *) &properties);
    ba0_get_token_analex ();
    ba0_scanf ("properties = %t[%s]", &properties);
    bad_init_intersectof_regchain (&ideal);
    ba0_scanf_printf ("%intersectof_regchain",
        "intersectof_regchain ([], %t[%s])", &ideal, &properties);
/*
 * RosenfeldGroebner (...)
 */
    ba0_get_token_analex ();
    ba0_scanf
        ("RosenfeldGroebner (eqns, ineqs, basefield = K, regchain = A, R, singsol = %s)",
        singsol);
/*
 * singsol
 */
    bad_init_splitting_control (&control);
    if (strcmp (singsol, "none") == 0)
      bad_set_first_leaf_only_splitting_control (&control, true);
/*
 * go
 */
    bad_Rosenfeld_Groebner (&ideal, &eqns, &ineqs, &K, &A, &control);
//    bad_set_settings_reduction (0, bad_probabilistic_redzero_strategy, 0);
    bad_remove_redundant_components_intersectof_regchain (&ideal, &ideal, &K);
//    bad_set_settings_reduction (0, 0, 0);
/*
 * Test also that the input polynomials are reduced to zero
 */
    b = true;
    for (int i = 0; i < ideal.inter.size; i++)
      {
        for (int j = 0; j < eqns.size; j++)
          {
            b = b && bad_is_a_reduced_to_zero_polynom_by_regchain
                (eqns.tab[j], ideal.inter.tab[i], bad_full_reduction);
          }
      }
    if (!b)
      BA0_RAISE_EXCEPTION (BA0_ERRALG);
/*
 * Remove from the output the equations coming from the parameters
 */
    for (int i = 0; i < ideal.inter.size; i++)
      bad_remove_zero_derivatives_of_tableof_parameter_from_regchain
          (ideal.inter.tab[i], ideal.inter.tab[i], &bav_global.parameters);
/*
 * Read the expected result in expected
 */
    ba0_init_table ((struct ba0_table *) &result);
    ba0_get_token_analex ();
    ba0_scanf ("result = %t[%t[%expanded_Az]]", &result);
    fclose (f);

    expected = ba0_new_printf ("%t[%t[%Az]]", &result);
/*
 * Print the computed result and compare with expected
 */
    computed = ba0_new_printf ("%intersectof_regchain_equations", &ideal);
    printf ("%s\n", computed);
    b = b && strcmp (computed, expected) == 0;
  }
  BA0_CATCH
  {
    if (ba0_global.exception.raised != BA0_ERRALR)
      BA0_RE_RAISE_EXCEPTION;
    fprintf (stderr, "Timelimit %d expired\n", (int) timelimit);
    b = false;
  }
  BA0_ENDTRY;

  bad_terminate (ba0_init_level);

  free (computed);
  free (expected);

  return b ? 0 : 1;
}
