#include "bad.h"

int
main (
    int argc,
    char **argv)
{
  struct bad_intersectof_regchain ideal;
  struct bad_regchain relations;
  struct bad_splitting_control control;
  struct bad_base_field K;
  struct bap_tableof_tableof_polynom_mpz result;
  struct bap_tableof_polynom_mpz eqns, ineqs, fieldeqns, nulles;
  struct bav_tableof_variable gens, X;
  bav_Iordering r;
  struct ba0_table blks;
  struct ba0_tableof_string ders, pars;
  ba0_int_p timelimit;
  FILE *f;
  volatile bool b = true;
  char nota[64], dring[64], singsol[64];
  static char buffer[32768], expected[32768];
/*
 * Are we able to open the file
 */
  if (argc != 2)
    {
      fprintf (stderr, "error: missing parameter on command line\n");
      return 1;
    }
  f = fopen (argv[1], "r");
  if (f == NULL)
    {
      fprintf (stderr, "error: unable to open %s\n", argv[1]);
      return 1;
    }
/*
 * First read timelimit
 */
  bad_restart (0, 0);
  BA0_TRY
  {
    ba0_set_input_FILE (f);
    ba0_get_token_analex ();
    ba0_scanf ("timelimit = %d", &timelimit);
  }
  BA0_CATCH
  {
    fprintf (stderr, "missing timelimit on first line\n");
    exit (1);
  }
  BA0_ENDTRY;
  bad_terminate (ba0_init_level);
/*
 * Then restart blad with this timelimit
 */
  bad_restart (timelimit, 0);

  BA0_TRY
  {
    ba0_set_input_FILE (f);
/*
 * {--> enter DifferentialAlgebra:-DifferentialRing, args = blocks = [...],
 *      parameters = [...], derivations = [...], notation = diff
 */
    ba0_get_token_analex ();
    while (ba0_type_token_analex () != ba0_no_token &&
        strcmp (ba0_value_token_analex (), "DifferentialRing") != 0)
      ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
      return 1;

    ba0_init_table (&blks);
    ba0_init_table ((struct ba0_table *) &pars);
    ba0_init_table ((struct ba0_table *) &ders);

    ba0_scanf
        ("DifferentialRing, args = blocks = %t[%b], parameters = %t[%six], derivations = %t[%s], notation = %s",
        &blks, &pars, &ders, nota);
/*
 * Do not bother with nota
 */
    bav_set_settings_variable (&bav_scanf_maple_all_variable, 0, 0, 0, 0);
/*
 * The ordering
 */
    ba0_sprintf (buffer,
        "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering",
        "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_global.parameters, &pars);
/*
 * Optionally:
 * {--> enter DifferentialAlgebra:-PretendRegularDifferentialChain,
 *      args = [_z1^2+1]
 *
 * Followed by:
 * {--> enter DifferentialAlgebra:-RosenfeldGroebner, args = [...],
 *      [...], DRing, 
 *      basefield = field(generators = [...], relations = regchain),
 *      singsol = none
 *
 * The basefield is optional.
 * The relations = regchain (which refers to the PretendRDC above) is
 * optional also.
 */
    while (ba0_type_token_analex () != ba0_no_token &&
        strcmp (ba0_value_token_analex (), "RosenfeldGroebner") != 0
        && strcmp (ba0_value_token_analex (),
            "PretendRegularDifferentialChain") != 0)
      ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
      return 1;
/*
 * The PretendRegularDifferentialChain. Will be used later.
 */
    bad_init_regchain (&relations);
    if (strcmp (ba0_value_token_analex (),
            "PretendRegularDifferentialChain") == 0)
      {
        ba0_init_table ((struct ba0_table *) &fieldeqns);
        ba0_scanf ("PretendRegularDifferentialChain, args = %t[%Az]",
            &fieldeqns);
        if (bav_global.R.ders.size > 0)
          ba0_scanf_printf ("%pretend_regchain",
              "regchain (%t[%Az], [differential, normalized])",
              &relations, &fieldeqns);
        else
          ba0_scanf_printf ("%pretend_regchain",
              "regchain (%t[%Az], [normalized])", &relations, &fieldeqns);
      }
    else
      {
        if (bav_global.R.ders.size > 0)
          ba0_sscanf2 ("regchain ([], [differential, normalized])",
              "%pretend_regchain", &relations);
        else
          ba0_sscanf2 ("regchain ([], [normalized])",
              "%pretend_regchain", &relations);
      }
/*
 * The lists of equations and inequations
 */
    while (ba0_type_token_analex () != ba0_no_token &&
        strcmp (ba0_value_token_analex (), "RosenfeldGroebner") != 0)
      ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
      return 1;

    ba0_init_table ((struct ba0_table *) &eqns);
    ba0_init_table ((struct ba0_table *) &ineqs);
    ba0_scanf ("RosenfeldGroebner, args = %t[%Az], %t[%Az], %s,",
        &eqns, &ineqs, dring);

    ba0_init_table ((struct ba0_table *) &nulles);
    bap_zero_derivatives_of_tableof_parameter_mpz (&nulles,
        &bav_global.parameters);
    ba0_concat_table ((struct ba0_table *) &eqns, (struct ba0_table *) &eqns,
        (struct ba0_table *) &nulles);

    ba0_sprintf (buffer, "eqns = %t[%Az]\n", &eqns);
    ba0_sprintf (buffer, "ineqs = %t[%Az]\n", &ineqs);
/*
 * The base field. Uses the relations, parsed above.
 */
    bad_init_base_field (&K);
    ba0_get_token_analex ();
    if (strcmp (ba0_value_token_analex (), "basefield") == 0)
      {
        ba0_init_table ((struct ba0_table *) &gens);
        ba0_scanf ("basefield = field");
        ba0_get_token_analex ();
        ba0_get_token_analex ();
        ba0_scanf ("generators = %t[%v]", &gens);
        bad_set_base_field_generators_and_relations
            (&K, &gens, &relations, &bav_global.parameters, false, false);
        ba0_init_table ((struct ba0_table *) &X);
        bad_base_field_implicit_generators (&X, &K, &gens, 0);
        if (X.size != 0)
          {
            ba0_fprintf (stderr, "implicit generators: %t[%v]\n", &X);
            return 1;
          }
      }
    else
      ba0_unget_token_analex (1);
    ba0_sprintf (buffer, "basefield = %base_field\n", &K);
/*
 * singsol
 */
    bad_init_splitting_control (&control);
    singsol[0] = '\0';
    while (ba0_type_token_analex () != ba0_no_token &&
        strcmp (ba0_value_token_analex (), "singsol") != 0)
      ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
      return 1;

    ba0_scanf ("singsol = %s", singsol);
    ba0_sprintf (buffer, "singsol = %s\n", singsol);
    if (strcmp (singsol, "none") == 0)
      bad_set_first_leaf_only_splitting_control (&control, true);
/*
 * go
 */
    bad_init_intersectof_regchain (&ideal);
#define NORM 1
#if defined NORM
    ba0_sscanf2
        ("intersectof_regchain ([], [differential, normalized])",
        "%intersectof_regchain", &ideal);
#else
    ba0_sscanf2
        ("intersectof_regchain ([], [differential, primitive, autoreduced])",
        "%intersectof_regchain", &ideal);
#endif
    bad_Rosenfeld_Groebner (&ideal, &eqns, &ineqs, &K, (struct bad_regchain *)0, &control);

    for (int i = 0; i < ideal.inter.size; i++)
      bad_remove_zero_derivatives_of_tableof_parameter_from_regchain
          (ideal.inter.tab[i], ideal.inter.tab[i], &bav_global.parameters);
/*
 * Print the computed result in buffer
 */
    ba0_sprintf (buffer, "%intersectof_regchain_equations", &ideal);
    printf ("%s\n", buffer);
/*
 * Read the expected result in expected
 */
    BA0_TRY
    {
      ba0_init_table ((struct ba0_table *) &result);
      ba0_get_token_analex ();
      ba0_scanf ("result = %t[%t[%Az]]", &result);
      ba0_sprintf (expected, "%t[%t[%Az]]", &result);

      fclose (f);

      b = strcmp (buffer, expected) == 0;
    }
    BA0_CATCH
    {
      ba0_printf ("** A result has been computed **\n");
      b = true;
    }
    BA0_ENDTRY;
  }
  BA0_CATCH
  {
    if (ba0_global.exception.raised != BA0_ERRALR)
      BA0_RE_RAISE_EXCEPTION;
    fprintf (stderr, "Timelimit %d expired\n", (int) timelimit);
    b = false;
  }
  BA0_ENDTRY;

  bad_terminate (ba0_init_level);
  return b ? 0 : 1;
}
