#include "bad.h"

int
main (
    int argc,
    char **argv)
{
  struct bad_attchain attrib;
  struct ba0_tableof_string str_attrib;
  struct bad_regchain A;
  struct bad_base_field K;
  struct bad_tableof_quadruple result;
  struct bap_tableof_polynom_mpz eqns, ineqns;
  struct bad_tableof_quadruple tabG;
  enum bad_typeof_reduction type_red;
  struct bad_splitting_tree tree;
  bav_Iordering r;
  struct ba0_table blks;
  struct ba0_tableof_string ders, pars;
  ba0_int_p timelimit;
  FILE *f;
  volatile bool b = true;
  char nota[64];
  static char buffer[32768], expected[32768];
/*
 * Are we able to open the file?
 */
  if (argc != 2)
    {
      fprintf (stderr, "error: missing filename on command line\n");
      return 1;
    }
  f = fopen (argv[1], "r");
  if (f == NULL)
    {
      fprintf (stderr, "error: unable to open %s\n", argv[1]);
      return 1;
    }
/*
 * First read timelimit
 */
  bad_restart (0, 0);
  BA0_TRY
  {
    ba0_set_input_FILE (f);
    ba0_get_token_analex ();
    ba0_scanf ("timelimit = %d", &timelimit);
  }
  BA0_CATCH
  {
    fprintf (stderr, "missing timelimit on first line\n");
    exit (1);
  }
  BA0_ENDTRY;
  bad_terminate (ba0_init_level);
/*
 * Then restart blad with this timelimit
 */
  bad_restart (timelimit, 0);

  BA0_TRY
  {
    ba0_set_input_FILE (f);
/*
 * R = DifferentialRing (...)
 */
    ba0_init_table (&blks);
    ba0_init_table ((struct ba0_table *) &pars);
    ba0_init_table ((struct ba0_table *) &ders);

    ba0_get_token_analex ();
    ba0_scanf
        ("R = DifferentialRing (blocks = %t[%b], parameters = %t[%six], derivations = %t[%s], notation = %s)",
        &blks, &pars, &ders, nota);
/*
 * Do not bother with nota
 */
    bav_set_settings_variable (&bav_scanf_maple_all_variable, 0, 0, 0, 0);
    bav_set_settings_rank (&bav_printf_stars_rank);
/*
 * The ordering
 */
    ba0_sprintf (buffer,
        "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering",
        "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_global.parameters, &pars);
/*
 * The regchain
 */
    bad_init_regchain (&A);
    ba0_get_token_analex ();
    ba0_scanf ("A = %regchain", &A);
/*
 * The base field
 */
    bad_init_base_field (&K);
    ba0_get_token_analex ();
    ba0_scanf ("K = %base_field", &K);
    ba0_sprintf (buffer, "basefield = %base_field\n", &K);
/*
 * tabG = %t[%quadruple]
 */
    ba0_init_table ((struct ba0_table *) &tabG);
    ba0_get_token_analex ();
    ba0_scanf ("tabG = %t[%quadruple]", &tabG);
/*
 * eqns = %t[%Az]
 * ineqns = %t[%Az]
 */
    ba0_init_table ((struct ba0_table *) &eqns);
    ba0_init_table ((struct ba0_table *) &ineqns);
    ba0_get_token_analex ();
    ba0_scanf ("eqns = %t[%Az]", &eqns);
    ba0_get_token_analex ();
    ba0_scanf ("ineqns = %t[%Az]", &ineqns);
/*
 * attrib = %t[%s]
 */
    ba0_init_table ((struct ba0_table *) &str_attrib);
    ba0_get_token_analex ();
    ba0_scanf ("attrib = %t[%s]", &str_attrib);
    bad_init_attchain (&attrib);
    bad_set_properties_attchain (&attrib, &str_attrib);
/*
 * type_red
 */
    if (bav_global.R.ders.size > 0)
      type_red = bad_full_reduction;
    else
      type_red = bad_algebraic_reduction;
/*
 * tree
 */
    bad_init_splitting_tree (&tree);
/*
 * go
 */
    ba0_get_token_analex ();
    ba0_scanf
        ("first_quadruple (tabG, attrib, eqns, ineqns, type_red, K, A, tree)");

    bad_first_quadruple (&tabG, &attrib, &eqns, &ineqns, type_red, &K, &A, &tree);
/*
 * Print the computed result 
 */
    ba0_printf ("%t[%quadruple]\n", &tabG);
/*
 * Read the expected result in expected and check
 */
    ba0_init_table ((struct ba0_table *) &result);
    ba0_get_token_analex ();
    ba0_scanf ("result = %t[%quadruple]", &result);

    fclose (f);

    ba0_sprintf (expected, "%t[%quadruple]", &result);
    ba0_sprintf (buffer, "%t[%quadruple]", &tabG);

    b = strcmp (buffer, expected) == 0;
  }
  BA0_CATCH
  {
    if (ba0_global.exception.raised != BA0_ERRALR)
      BA0_RE_RAISE_EXCEPTION;
    fprintf (stderr, "Timelimit %d expired\n", (int) timelimit);
    b = false;
  }
  BA0_ENDTRY;

  bad_terminate (ba0_init_level);
  return b ? 0 : 1;
}
