#include "bad.h"

int
main (
    int argc,
    char **argv)
{
  struct bad_base_field K;
  struct bap_polynom_mpz *A, B;
  struct bav_variable *v;
  ba0_int_p i;
  struct bad_tableof_quadruple tabG;
  struct bap_tableof_polynom_mpz tabP;
  struct bad_splitting_tree tree;
  bav_Iordering r;
  struct ba0_table blks;
  struct ba0_tableof_string ders, pars;
  ba0_int_p timelimit;
  FILE *f;
  volatile bool b = true;
  char nota[64];
  static char buffer[32768], expected[32768];
  struct bad_tableof_quadruple result_tabG;
  struct bap_tableof_polynom_mpz result_tabP;
/*
 * Are we able to open the file?
 */
  if (argc != 2)
    {
      fprintf (stderr, "error: missing filename on command line\n");
      return 1;
    }
  f = fopen (argv[1], "r");
  if (f == NULL)
    {
      fprintf (stderr, "error: unable to open %s\n", argv[1]);
      return 1;
    }
/*
 * First read timelimit
 */
  bad_restart (0, 0);
  BA0_TRY
  {
    ba0_set_input_FILE (f);
    ba0_get_token_analex ();
    ba0_scanf ("timelimit = %d", &timelimit);
  }
  BA0_CATCH
  {
    fprintf (stderr, "missing timelimit on first line\n");
    exit (1);
  }
  BA0_ENDTRY;
  bad_terminate (ba0_init_level);
/*
 * Then restart blad with this timelimit
 */
  bad_restart (timelimit, 0);

  BA0_TRY
  {
    ba0_set_input_FILE (f);
/*
 * R = DifferentialRing (...)
 */
    ba0_init_table (&blks);
    ba0_init_table ((struct ba0_table *) &pars);
    ba0_init_table ((struct ba0_table *) &ders);

    ba0_get_token_analex ();
    ba0_scanf
        ("R = DifferentialRing (blocks = %t[%b], parameters = %t[%six], derivations = %t[%s], notation = %s)",
        &blks, &pars, &ders, nota);
/*
 * Do not bother with nota
 */
    bav_set_settings_variable (&bav_scanf_maple_all_variable, 0, 0, 0, 0);
    bav_set_settings_rank (&bav_printf_stars_rank);
/*
 * The ordering
 */
    ba0_sprintf (buffer,
        "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering",
        "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_global.parameters, &pars);
/*
 * The base field
 */
    bad_init_base_field (&K);
    ba0_get_token_analex ();
    ba0_scanf ("K = %base_field", &K);
    ba0_sprintf (buffer, "basefield = %base_field\n", &K);
/*
 * tabG = %t[%quadruple]
 */
    ba0_init_table ((struct ba0_table *) &tabG);
    ba0_get_token_analex ();
    ba0_scanf ("tabG = %t[%quadruple]", &tabG);
    if (tabG.size == 0)
      BA0_RAISE_EXCEPTION (BA0_ERRALG);
/*
 * B = %Az
 */
    bap_init_polynom_mpz (&B);
    ba0_get_token_analex ();
    ba0_scanf ("B = %Az", &B);
    v = bap_leader_polynom_mpz (&B);
    if (!bad_is_leader_of_regchain (v, &tabG.tab[tabG.size - 1]->A, &i))
      BA0_RAISE_EXCEPTION (BA0_ERRALG);
    A = tabG.tab[tabG.size - 1]->A.decision_system.tab[i];

    if (bap_degree_polynom_mpz (A, v) <= bap_degree_polynom_mpz (&B, v))
      BA0_RAISE_EXCEPTION (BA0_ERRALG);
/*
 * tree
 */
    bad_init_splitting_tree (&tree);
/*
 * go
 */
    ba0_get_token_analex ();
    ba0_scanf ("gcd_mod_quadruple (A, B, v, K, tree)");

    ba0_init_table ((struct ba0_table *) &tabP);
    ba0_realloc2_table ((struct ba0_table *) &tabP, 1,
        (ba0_new_function *) & bap_new_polynom_mpz);
    tabP.size = 1;

    bad_gcd_mod_quadruple (&tabP, &tabG, A, &B, v, &K, &tree);
/*
 * Print the computed result 
 */
    ba0_printf ("%t[%Az]\n", &tabP);
    ba0_printf ("%t[%quadruple]\n", &tabG);
/*
 * Read the expected result in expected
 */
    ba0_init_table ((struct ba0_table *) &result_tabP);
    ba0_get_token_analex ();
    ba0_scanf ("result_tabP = %t[%Az]", &result_tabP);

    ba0_init_table ((struct ba0_table *) &result_tabG);
    ba0_get_token_analex ();
    ba0_scanf ("result_tabG = %t[%quadruple]", &result_tabG);

    fclose (f);

    ba0_sprintf (expected, "%t[%Az]", &result_tabP);
    ba0_sprintf (buffer, "%t[%Az]", &tabP);
    b = strcmp (buffer, expected) == 0;

    ba0_sprintf (expected, "%t[%quadruple]", &result_tabG);
    ba0_sprintf (buffer, "%t[%quadruple]", &tabG);
    b = b && strcmp (buffer, expected) == 0;
  }
  BA0_CATCH
  {
    if (ba0_global.exception.raised != BA0_ERRALR)
      BA0_RE_RAISE_EXCEPTION;
    fprintf (stderr, "Timelimit %d expired\n", (int) timelimit);
    b = false;
  }
  BA0_ENDTRY;

  bad_terminate (ba0_init_level);
  return b ? 0 : 1;
}
