#include "bap_polynom_COEFF.h"
#include "bap__check_COEFF.h"

#define BAD_FLAG_COEFF

BAP_DLL void
bap__check_ordering_COEFF (
    struct bap_polynom_COEFF *A)
{
#if defined (BA0_HEAVY_DEBUG)
  ba0_int_p i;

  for (i = 1; i < A->total_rank.size; i++)
    if (bav_R_variable_number (A->total_rank.rg[i - 1].var) <=
        bav_R_variable_number (A->total_rank.rg[i].var))
      BA0_RAISE_EXCEPTION (BA0_ERRALG);

  if (A->clot != (struct bap_clot_COEFF *) 0
      && ba0_which_stack (A->clot) == (struct ba0_stack *) 0)
    BA0_RAISE_EXCEPTION (BA0_ERRALG);
#else
  A = (struct bap_polynom_COEFF *) 0;
#endif
}

#if defined (BA0_HEAVY_DEBUG)
static void
bap__check_compatible_ordering_COEFF (
    struct bap_polynom_COEFF *A,
    struct bap_polynom_COEFF *B)
{
  bap__check_ordering_COEFF (A);
  bap__check_ordering_COEFF (B);
}
#endif

BAP_DLL void
bap__check_compatible_COEFF (
    struct bap_polynom_COEFF *A,
    struct bap_polynom_COEFF *B)
{
#if defined (BA0_HEAVY_DEBUG)
  bap__check_compatible_ordering_COEFF (A, B);
#else
  A = (struct bap_polynom_COEFF *) 0;
  B = (struct bap_polynom_COEFF *) 0;
#endif
}

#undef BAD_FLAG_COEFF
