/*
	The problem is :
	write a program which takes as input a list of points and
outputs the interpolation polynomial computed using Lagrange's formula.
The program was written in less than 1/2 hour and is ill-designed.
*/

#include "bap.h"

/*
   T is a table whose entries are tables of two ba0_mpq_t.
*/

static struct bap_polynom_mpq *
num_term (
    struct ba0_table *T,
    int i)
{
  struct bap_polynom_mpq *F, *P;
  struct ba0_table *Point;
  int j;

  F = bap_new_polynom_mpq ();
  P = bap_new_polynom_one_mpq ();
  for (j = 0; j < T->size; j++)
    {
      if (j != i)
        {
          Point = (struct ba0_table *) T->tab[j];
          ba0_scanf_printf ("%Aq;", "(x - %q);", F, Point->tab[0]);
          bap_mul_polynom_mpq (P, P, F);
        }
    }
  return P;
}

static void
den_term (
    ba0_mpq_t Q,
    struct ba0_table *T,
    int i)
{
  ba0_mpq_t xi, xi_xj;
  struct ba0_table *Point;
  int j;

  ba0_mpq_set_ui (Q, 1);
  ba0_mpq_init (xi);
  ba0_mpq_init (xi_xj);
  ba0_mpq_set (xi,
      (ba0__mpq_struct *) ((struct ba0_table *) T->tab[i])->tab[0]);

  for (j = 0; j < T->size; j++)
    {
      if (j != i)
        {
          Point = (struct ba0_table *) T->tab[j];
          ba0_mpq_sub (xi_xj, xi, (ba0__mpq_struct *) Point->tab[0]);
          ba0_mpq_mul (Q, Q, xi_xj);
        }
    }
}

static struct bap_polynom_mpq *
term (
    struct ba0_table *T,
    int i)
{
  struct bap_polynom_mpq *P;
  struct ba0_table *Point;
  ba0_mpq_t Q;

  P = num_term (T, i);
  ba0_mpq_init (Q);
  den_term (Q, T, i);
  Point = (struct ba0_table *) T->tab[i];
  ba0_mpq_div (Q, (ba0__mpq_struct *) Point->tab[1], Q);
  bap_mul_polynom_numeric_mpq (P, P, Q);
  return P;
}

static struct bap_polynom_mpq *
lagrange (
    struct ba0_table *T)
{
  struct bap_polynom_mpq *P;
  int i;

  P = bap_new_polynom_mpq ();
  for (i = 0; i < T->size; i++)
    bap_add_polynom_mpq (P, P, term (T, i));
  return P;
}

int
main (
    void)
{
  bav_Iordering r;
  struct bap_polynom_mpq *P;
  struct ba0_table *T;
  struct ba0_mark M;
  char buffer[256];
  bool b;

  bap_restart (0, 0);

  ba0_sscanf2 ("ordering (derivations = [t], blocks = [x])", "%ordering", &r);
  bav_R_push_ordering (r);

  ba0_record (&M);

  T = ba0_new_table ();
  ba0_sscanf2 ("[[0,3], [1,-4/21], [-1,10/21]]", "%t[%t[%q]]", T);

  P = lagrange (T);
  ba0_garbage ("%Aq", &M, &P);

  ba0_sprintf (buffer, "%Aq", P);
  b = strcmp (buffer, "-20/7*x^2 - 1/3*x + 3") == 0;

  bap_terminate (ba0_init_level);
  return b ? 0 : 1;
}
