#include "bap.h"

int
main (
    void)
{
  struct bap_polynom_mpz A, Abar, B, C;
  struct bav_term T;
  bav_Iordering r, rbar;
  char buffer[256];
  bool b;

  bap_restart (0, 0);
  ba0_sscanf2 ("ordering (derivations = [x], blocks = [a, u, v, b])",
      "%ordering", &r);
  ba0_sscanf2 ("ordering (derivations = [x], blocks = [a, v, u, b])",
      "%ordering", &rbar);
  bav_R_push_ordering (r);

  bap_init_polynom_mpz (&A);
  bap_init_readonly_polynom_mpz (&Abar);
  bap_init_readonly_polynom_mpz (&B);
  bap_init_readonly_polynom_mpz (&C);
  bav_init_term (&T);

  b = true;

  ba0_sscanf2 ("u[x,x] + u[x]^2 + u[x]*u + u[x]*v + u + v + 1, u[x]",
      "%Az, %term", &A, &T);
  bap_split_polynom_mpz (&B, &C, &A, &T);
  ba0_sprintf (buffer, "%Az, %Az", &B, &C);
  b = b && strcmp (buffer, "u[x,x] + u[x]^2 + u[x]*u + u[x]*v, u + v + 1") == 0;

  bav_R_push_ordering (rbar);
  bap_sort_polynom_mpz (&Abar, &A);
  bap_split_polynom_mpz (&B, &C, &Abar, &T);
  ba0_sprintf (buffer, "%Az, %Az", &B, &C);
  b = b && strcmp (buffer, "v*u[x] + v + u[x,x] + u[x]^2 + u[x]*u, u + 1") == 0;
  bav_R_pull_ordering ();

  ba0_sscanf2
      ("u[x,x] + u[x]^3 + u[x]^2*u + u[x]^2*v + u + v + 1, u[x]",
      "%Az, %term", &A, &T);
  bap_split_polynom_mpz (&B, &C, &A, &T);
  ba0_sprintf (buffer, "%Az, %Az", &B, &C);
  b = b && strcmp
      (buffer, "u[x,x] + u[x]^3 + u[x]^2*u + u[x]^2*v, u + v + 1") == 0;

  bav_R_push_ordering (rbar);
  bap_sort_polynom_mpz (&Abar, &A);
  bap_split_polynom_mpz (&B, &C, &Abar, &T);
  ba0_sprintf (buffer, "%Az, %Az", &B, &C);
  b = b && strcmp
      (buffer, "v*u[x]^2 + v + u[x,x] + u[x]^3 + u[x]^2*u, u + 1") == 0;
  bav_R_pull_ordering ();

  ba0_sscanf2 ("u[x,x] + u[x]^3 + u[x]^2*u + u[x]^2*v + u + v + 1, a",
      "%Az, %term", &A, &T);
  bap_split_polynom_mpz (&B, &C, &A, &T);
  ba0_sprintf (buffer, "%Az, %Az", &B, &C);
  b = b && strcmp
      (buffer, "0, u[x,x] + u[x]^3 + u[x]^2*u + u[x]^2*v + u + v + 1") == 0;
  b = b && bap_is_zero_polynom_mpz (&B);

  bav_R_push_ordering (rbar);
  bap_sort_polynom_mpz (&Abar, &A);
  bap_split_polynom_mpz (&B, &C, &Abar, &T);
  ba0_sprintf (buffer, "%Az, %Az", &B, &C);
  b = b && strcmp
      (buffer, "0, v*u[x]^2 + v + u[x,x] + u[x]^3 + u[x]^2*u + u + 1") == 0;
  b = b && bap_is_zero_polynom_mpz (&B);
  bav_R_pull_ordering ();

  ba0_sscanf2 ("u[x,x] + u[x]^3 + u[x]^2*u + u[x]^2*v, u[x]^2",
      "%Az, %term", &A, &T);
  bap_split_polynom_mpz (&B, &C, &A, &T);
  ba0_sprintf (buffer, "%Az, %Az", &B, &C);
  b = b && strcmp (buffer, "u[x,x] + u[x]^3 + u[x]^2*u + u[x]^2*v, 0") == 0;
  b = b && bap_is_zero_polynom_mpz (&C);

  bav_R_push_ordering (rbar);
  bap_sort_polynom_mpz (&Abar, &A);
  bap_split_polynom_mpz (&B, &C, &Abar, &T);
  ba0_sprintf (buffer, "%Az, %Az", &B, &C);
  b = b && strcmp (buffer, "v*u[x]^2 + u[x,x] + u[x]^3 + u[x]^2*u, 0") == 0;
  b = b && bap_is_zero_polynom_mpz (&C);

  bav_R_pull_ordering ();
  bap_terminate (ba0_init_level);
  return b ? 0 : 1;
}
