#include "bap.h"

int
main (
    int argc,
    char **argv)
{
  struct bap_tableof_polynom_mpz V;
  struct bap_product_mpz prod;
  struct bap_polynom_mpz P, Q, S;
  struct bav_variable *v;

  bav_Iordering r;
  struct ba0_table blks;
  struct ba0_tableof_string ders, pars;
  ba0_int_p timelimit;
  FILE *f;
  volatile bool b = true;
  char nota[64];
  static char buffer[32768], expected[32768];
/*
 * Are we able to open the file?
 */
  if (argc != 2)
    {
      fprintf (stderr, "error: missing filename on command line\n");
      return 1;
    }
  f = fopen (argv[1], "r");
  if (f == NULL)
    {
      fprintf (stderr, "error: unable to open %s\n", argv[1]);
      return 1;
    }
/*
 * First read timelimit
 */
  bap_restart (0, 0);
  BA0_TRY
  {
    ba0_set_input_FILE (f);
    ba0_get_token_analex ();
    ba0_scanf ("timelimit = %d", &timelimit);
  }
  BA0_CATCH
  {
    fprintf (stderr, "missing timelimit on first line\n");
    exit (1);
  }
  BA0_ENDTRY;
  bap_terminate (ba0_init_level);
/*
 * Then restart blad with this timelimit
 */
  bap_restart (timelimit, 0);

  BA0_TRY
  {
    ba0_set_input_FILE (f);
/*
 * R = DifferentialRing (...)
 */
    ba0_init_table (&blks);
    ba0_init_table ((struct ba0_table *) &pars);
    ba0_init_table ((struct ba0_table *) &ders);

    ba0_get_token_analex ();
    ba0_scanf
        ("R = DifferentialRing (blocks = %t[%b], parameters = %t[%six], derivations = %t[%s], notation = %s)",
        &blks, &pars, &ders, nota);
/*
 * Do not bother with nota
 */
    bav_set_settings_variable (&bav_scanf_maple_all_variable, 0, 0, 0, 0);
    bav_set_settings_rank (&bav_printf_stars_rank);
/*
 * The ordering
 */
    ba0_sprintf (buffer,
        "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering",
        "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_global.parameters, &pars);
/*
 * P = %Az
 */
    ba0_get_token_analex ();
    bap_init_polynom_mpz (&P);
    ba0_scanf ("P = %Az", &P);
/*
 * Q = %Az
 */
    ba0_get_token_analex ();
    bap_init_polynom_mpz (&Q);
    ba0_scanf ("Q = %Az", &Q);
/*
 * v = %v
 */
    ba0_get_token_analex ();
    ba0_scanf ("v = %v", &v);
/*
 * go
 */
    ba0_get_token_analex ();
    ba0_scanf ("resultant (P, Q)");

    ba0_init_table ((struct ba0_table *) &V);
    ba0_realloc2_table
        ((struct ba0_table *) &V, 3, (ba0_new_function *) & bap_new_polynom_mpz);
    V.size = 3;

    bap_lsr3_Ducos_polynom_mpz (&V, &P, &Q, v);

    bap_init_polynom_mpz (&S);
    ba0_scanf_printf ("%Az", "%Az - (%Az)*(%Az) - (%Az)*(%Az)",
      &S, V.tab[0], V.tab[1], &P, V.tab[2], &Q);

    b = bap_is_zero_polynom_mpz (&S);

    bap_init_product_mpz (&prod);
    bap_resultant2_Ducos_polynom_mpz (&prod, &P, &Q, v);
    bap_expand_product_mpz (&S, &prod);

    b = b && bap_equal_polynom_mpz (&S, V.tab[0]);
  }
  BA0_CATCH
  {
    if (ba0_global.exception.raised != BA0_ERRALR)
      BA0_RE_RAISE_EXCEPTION;
    fprintf (stderr, "Timelimit %d expired\n", (int) timelimit);
    b = false;
  }
  BA0_ENDTRY;

  bap_terminate (ba0_init_level);
  return b ? 0 : 1;
}
