#include "bap.h"

int
main (
    int argc,
    char **argv)
{
  struct bap_itercoeff_mpz iter;
  struct bap_polynom_mpz poly, coeff, sorted_poly;
  struct bav_variable *v, *w;
  struct bap_tableof_polynom_mpz result, T, U;

  bav_Iordering r;
  struct ba0_table blks;
  struct ba0_tableof_string ders, pars;
  ba0_int_p timelimit;
  FILE *f;
  volatile bool b = true;
  char nota[64];
  static char buffer[32768], expected[32768];
/*
 * Are we able to open the file?
 */
  if (argc != 2)
    {
      fprintf (stderr, "error: missing filename on command line\n");
      return 1;
    }
  f = fopen (argv[1], "r");
  if (f == NULL)
    {
      fprintf (stderr, "error: unable to open %s\n", argv[1]);
      return 1;
    }
  bap_restart (0, 0);
  BA0_TRY
  {
    ba0_set_input_FILE (f);
/*
 * R = DifferentialRing (...)
 */
    ba0_init_table (&blks);
    ba0_init_table ((struct ba0_table *) &pars);
    ba0_init_table ((struct ba0_table *) &ders);

    ba0_get_token_analex ();
    ba0_scanf
        ("R = DifferentialRing (blocks = %t[%b], parameters = %t[%six], derivations = %t[%s], notation = %s)",
        &blks, &pars, &ders, nota);
/*
 * Do not bother with nota
 */
    bav_set_settings_variable (&bav_scanf_maple_all_variable, 0, 0, 0, 0);
    bav_set_settings_rank (&bav_printf_stars_rank);
/*
 * The ordering
 */
    ba0_sprintf (buffer,
        "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering",
        "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_global.parameters, &pars);
/*
 * poly = %Az
 */
    ba0_get_token_analex ();
    bap_init_polynom_mpz (&poly);
    ba0_scanf ("poly = %Az", &poly);
/*
 * v = %v
 */
    ba0_get_token_analex ();
    ba0_scanf ("v = %v", &v);
/*
 * w = %v
 */
    ba0_get_token_analex ();
    ba0_scanf ("w = %v", &w);
/*
 * go
 */
    ba0_get_token_analex ();
    ba0_scanf ("end_to_begin_itercoeff (poly, v)");
    ba0_init_table ((struct ba0_table *) &T);
    ba0_realloc2_table ((struct ba0_table *) &T, 100,
        (ba0_new_function *) & bap_new_polynom_mpz);

    bap_end_itercoeff_mpz (&iter, &poly, v);
    bap_init_readonly_polynom_mpz (&coeff);
    while (!bap_outof_itercoeff_mpz (&iter))
      {
        bap_coeff_itercoeff_mpz (&coeff, &iter);
        bap_set_polynom_mpz (T.tab[T.size], &coeff);
        T.size += 1;
        bap_prev_itercoeff_mpz (&iter);
      }
    bap_close_itercoeff_mpz (&iter);

    r = bav_R_copy_ordering (bav_R_Iordering ());
    bav_R_push_ordering (r);
    bav_R_set_maximal_variable (v);
    bap_init_readonly_polynom_mpz (&sorted_poly);
    bap_sort_polynom_mpz (&sorted_poly, &poly);
    ba0_init_table ((struct ba0_table *) &U);
    ba0_realloc2_table ((struct ba0_table *) &U, 100,
        (ba0_new_function *) & bap_new_polynom_mpz);

    bap_end_itercoeff_mpz (&iter, &sorted_poly, w);
    bap_init_readonly_polynom_mpz (&coeff);
    while (!bap_outof_itercoeff_mpz (&iter))
      {
        bap_coeff_itercoeff_mpz (&coeff, &iter);
        bap_set_polynom_mpz (U.tab[U.size], &coeff);
        U.size += 1;
        bap_prev_itercoeff_mpz (&iter);
      }
    bap_close_itercoeff_mpz (&iter);

/*
 * Print the computed result 
 */
    ba0_printf ("%t[%Az]\n", &T);
/*
 * Read the expected result in expected and check
 */
    ba0_init_table ((struct ba0_table *) &result);
    ba0_get_token_analex ();
    ba0_scanf ("result = %t[%Az]", &result);

    ba0_sprintf (expected, "%t[%Az]", &result);
    ba0_sprintf (buffer, "%t[%Az]", &T);

    b = strcmp (buffer, expected) == 0;

    ba0_get_token_analex ();
    ba0_scanf ("result = %t[%Az]", &result);

    fclose (f);

    ba0_sprintf (expected, "%t[%Az]", &result);
    ba0_sprintf (buffer, "%t[%Az]", &U);
    b = b && strcmp (buffer, expected) == 0;
  }
  BA0_CATCH
  {
    if (ba0_global.exception.raised != BA0_ERRALR)
      BA0_RE_RAISE_EXCEPTION;
    fprintf (stderr, "Timelimit %d expired\n", (int) timelimit);
    b = false;
  }
  BA0_ENDTRY;

  bap_terminate (ba0_init_level);
  return b ? 0 : 1;
}
