#include "bav.h"

int
main (
    int argc,
    char **argv)
{
  struct bav_variable *result;
  struct ba0_tableof_string notations;
  struct bav_variable *v;
  ba0_int_p i, int_notations;

  bav_Iordering r;
  struct ba0_table blks;
  struct ba0_tableof_string ders, pars;
  FILE *f;
  volatile bool b = true;
  char nota[64];
  static char buffer[32768], expected[32768];

/*
 * Are we able to open the file?
 */
  if (argc != 2)
    {
      fprintf (stderr, "error: missing filename on command line\n");
      return 1;
    }
  f = fopen (argv[1], "r");
  if (f == NULL)
    {
      fprintf (stderr, "unable to open: %s\n", argv[1]);
      return 1;
    }

  bav_restart (0, 0);

  BA0_TRY
  {
    ba0_set_input_FILE (f);
/*
 * R = DifferentialRing (...)
 */
    ba0_init_table (&blks);
    ba0_init_table ((struct ba0_table *) &pars);
    ba0_init_table ((struct ba0_table *) &ders);

    ba0_get_token_analex ();
    ba0_scanf
        ("R = DifferentialRing (blocks = %t[%b], parameters = %t[%six], derivations = %t[%s], notation = %s)",
        &blks, &pars, &ders, nota);
/*
 * Do not bother with nota
 */
    bav_set_settings_variable (&bav_scanf_maple_all_variable, 0, 0, 0, 0);
    bav_set_settings_rank (&bav_printf_stars_rank);
/*
 * The ordering
 */
    ba0_sprintf (buffer,
        "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering",
        "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_global.parameters, &pars);
/*
 * v = %v
 */
    ba0_get_token_analex ();
    bav_global.variable.notations = 0xff;
    ba0_scanf ("v = %v", &v);
/*
 * result = %v
 * notation = %t[%s]
 */
    bav_set_settings_variable (&bav_scanf_jet_variable, 0, 0, 0, 0);

    ba0_get_token_analex ();
    ba0_scanf ("result = %v", &result);
    ba0_get_token_analex ();
    ba0_init_table ((struct ba0_table *) &notations);
    ba0_scanf ("notations = %t[%s]", &notations);
    fclose (f);

    int_notations = 0;
    for (i = 0; i < notations.size; i++)
      if (strcmp (notations.tab[i], "jet") == 0)
        int_notations |= BAV_jet_FLAG;
      else if (strcmp (notations.tab[i], "tjet") == 0)
        int_notations |= BAV_tjet_FLAG;
      else if (strcmp (notations.tab[i], "jet0") == 0)
        int_notations |= BAV_jet0_FLAG;
      else if (strcmp (notations.tab[i], "diff") == 0)
        int_notations |= BAV_diff_FLAG;
      else if (strcmp (notations.tab[i], "Diff") == 0)
        int_notations |= BAV_Diff_FLAG;
      else if (strcmp (notations.tab[i], "Derivative") == 0)
        int_notations |= BAV_Derivative_FLAG;
      else if (strcmp (notations.tab[i], "D") == 0)
        int_notations |= BAV_D_FLAG;
      else
        BA0_RAISE_EXCEPTION (BA0_ERRALG);

    b = v == result && int_notations == bav_global.variable.notations;
  }
  BA0_CATCH
  {
    fprintf (stderr, "syntax error in the test file\n");
    b = false;
  }
  BA0_ENDTRY;

  bav_terminate (ba0_init_level);
  return b ? 0 : 1;
}
