#include "baz.h"

int
main (
    void)
{
  bav_Iordering r;
  struct baz_ratfrac A, B, F;
  struct baz_tableof_ratfrac coeffs, terms;
  struct baz_tableof_ratfrac coeffs2, terms2;
  ba0_int_p i;
  bool b;

  baz_restart (0, 0);
  ba0_sscanf2
      ("ordering (derivations = [t], blocks = [y, [k12,k21,Ve]])",
      "%ordering", &r);
  bav_R_push_ordering (r);

  baz_init_ratfrac (&F);
  ba0_sscanf2
      ("y[t,t]*y^2+2*y[t,t]*y+y[t,t]+y[t]*y^2*k12+y[t]*y^2*k21+2*y[t]*y*k12+2*y[t]*y*k21+y[t]*k12+y[t]*k21+y[t]*Ve+y^2*k21*Ve+y*k21*Ve",
      "%Qz", &F);

  ba0_init_table ((struct ba0_table *) &coeffs);
  ba0_init_table ((struct ba0_table *) &terms);
/*
 * Computation in place
 */
  ba0_sscanf2
      ("[1, 2, 1, k12+k21, 2*k12+2*k21, k12+k21+Ve, k21*Ve, k21*Ve]",
      "%t[%Qz]", &coeffs);
  ba0_sscanf2
      ("[y[t,t]*y^2, y[t,t]*y, y[t,t], y[t]*y^2, y[t]*y, y[t], y^2, y]",
      "%t[%Qz]", &terms);

  baz_collect_terms_tableof_ratfrac (&coeffs, &terms, &coeffs, &terms);
/*
    ba0_printf ("%t[%Qz]\n", &coeffs);
    ba0_printf ("%t[%Qz]\n", &terms);
 */
  baz_init_ratfrac (&A);
  baz_init_ratfrac (&B);
  baz_set_ratfrac_zero (&A);
  for (i = 0; i < coeffs.size; i++)
    {
      baz_mul_ratfrac (&B, coeffs.tab[i], terms.tab[i]);
      baz_add_ratfrac (&A, &A, &B);
    }
  baz_sub_ratfrac (&A, &A, &F);

  b = baz_is_zero_ratfrac (&A) && coeffs.size == 4;
/*
 * Computation not in place
 */
  ba0_sscanf2
      ("[1, 2, 1, k12+k21, 2*k12+2*k21, k12+k21+Ve, k21*Ve, k21*Ve]",
      "%t[%Qz]", &coeffs);
  ba0_sscanf2
      ("[y[t,t]*y^2, y[t,t]*y, y[t,t], y[t]*y^2, y[t]*y, y[t], y^2, y]",
      "%t[%Qz]", &terms);
  ba0_init_table ((struct ba0_table *) &coeffs2);
  ba0_init_table ((struct ba0_table *) &terms2);
  baz_collect_terms_tableof_ratfrac (&coeffs2, &terms2, &coeffs, &terms);
/*
    ba0_printf ("%t[%Qz]\n", &coeffs2);
    ba0_printf ("%t[%Qz]\n", &terms2);
 */
  baz_set_ratfrac_zero (&A);
  for (i = 0; i < coeffs2.size; i++)
    {
      baz_mul_ratfrac (&B, coeffs2.tab[i], terms2.tab[i]);
      baz_add_ratfrac (&A, &A, &B);
    }
  baz_sub_ratfrac (&A, &A, &F);

  b = b && baz_is_zero_ratfrac (&A) && coeffs2.size == 4;
/*
 * With true rational fractions
 */
  ba0_sscanf2
      ("(y[t,t]*y^2+2*y[t,t]*y+y[t,t]+y[t]*y^2*k12+y[t]*y^2*k21+2*y[t]*y*k12+2*y[t]*y*k21+y[t]*k12+y[t]*k21+y[t]*Ve+y^2*k21*Ve+y*k21*Ve)/(Ve*y)",
      "%Qz", &F);

  ba0_sscanf2
      ("[1/Ve, 2/Ve, 1/Ve, (k12+k21)/Ve, (2*k12+2*k21)/Ve, (k12+k21+Ve)/Ve, k21, k21]",
      "%t[%Qz]", &coeffs);
  ba0_sscanf2
      ("[y[t,t]*y, y[t,t], y[t,t]/y, y[t]*y, y[t], y[t]/y, y, 1]",
      "%t[%Qz]", &terms);

  baz_collect_terms_tableof_ratfrac (&coeffs2, &terms2, &coeffs, &terms);
/*
    ba0_printf ("%t[%Qz]\n", &coeffs2);
    ba0_printf ("%t[%Qz]\n", &terms2);
 */
  baz_set_ratfrac_zero (&A);
  for (i = 0; i < coeffs2.size; i++)
    {
      baz_mul_ratfrac (&B, coeffs2.tab[i], terms2.tab[i]);
      baz_add_ratfrac (&A, &A, &B);
    }
  baz_sub_ratfrac (&A, &A, &F);

  b = b && baz_is_zero_ratfrac (&A) && coeffs2.size == 4;

  bav_R_pull_ordering ();
  baz_terminate (ba0_init_level);
  return b ? 0 : 1;
}
