#include "baz.h"

int
main (
    void)
{
  bav_Iordering r;
  struct baz_ratfrac Q, R, W;
  struct bav_tableof_variable nulles;
  struct bav_tableof_parameter params;
  struct bav_symbol *x;
  bool b;
  static char buffer[1024];

  baz_restart (0, 0);
  ba0_sscanf2 ("ordering (derivations = [x], blocks = [[u, v], w])",
      "%ordering", &r);
  bav_R_push_ordering (r);

  baz_init_ratfrac (&Q);
  baz_init_ratfrac (&R);
  baz_init_ratfrac (&W);

  ba0_init_table ((struct ba0_table *) &nulles);
  ba0_init_table ((struct ba0_table *) &params);

  b = true;

  ba0_sscanf2 ("1 + x, x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &params);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "(x^2 + 2*x)/(2), 0") == 0;

  ba0_sscanf2 ("u + (v[x,x]*v - v[x]^2)/v^2, x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &params);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "v[x]/(v), u") == 0;

  ba0_sscanf2 ("u[x,x]^2 + (v[x,x]*v - v[x]^2)/v^2, x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &params);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "v[x]/(v), u[x,x]^2") == 0;

  ba0_sscanf2 ("u[x]*v[x] + u[x]*w[x], x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &params);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "u*w[x], u[x]*v[x] - u*w[x,x]") == 0;

  bav_R_pull_ordering ();
  baz_terminate (ba0_init_level);
  return b ? 0 : 1;
}
