#include "baz.h"

int
main (
    void)
{
  bav_Iordering r;
  struct baz_ratfrac Q, R, W;
  struct bav_tableof_variable nulles;
  struct bav_symbol *x;
  bool b;
  static char buffer[1024];


  baz_restart (0, 0);
  ba0_sscanf2
      ("ordering (derivations = [x,y], blocks = [[u, v], w, a])",
      "%ordering", &r);
  bav_R_push_ordering (r);
  ba0_sscanf2 ("[a]", "%t[%param]", &bav_global.parameters);

  baz_init_ratfrac (&Q);
  baz_init_ratfrac (&R);
  baz_init_ratfrac (&W);
  ba0_init_table ((struct ba0_table *) &nulles);

  b = true;

  ba0_sscanf2 ("a + 2*x, x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &bav_global.parameters);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "a*x + x^2, 0") == 0;
/*
 * Used to be a bug
 */
  ba0_sscanf2 ("a*x + 1/x^3, x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &bav_global.parameters);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "(a*x^4 - 1)/(2*x^2), 0") == 0;
/*
 * Used to be a bug
 */
  ba0_sscanf2 ("u[x]/(v[y]^2 + a), x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &bav_global.parameters);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "0, u[x]/(v[y]^2 + a)") == 0;
/*
 * Used to be a bug
 */
  ba0_sscanf2 ("u[x]/(1 + u^2), x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &bav_global.parameters);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "-u/(u^2 + 1), 2*u[x]/(u^4 + 2*u^2 + 1)") == 0;

  ba0_sscanf2 ("u[x]/(v^2*(w+1)*(v+w)^3), x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &bav_global.parameters);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b
      && strcmp (buffer,
      "u/(v^5*w + v^5 + 3*v^4*w^2 + 3*v^4*w + 3*v^3*w^3 + 3*v^3*w^2 + v^2*w^4 + v^2*w^3), (5*v[x]*u*v*w + 5*v[x]*u*v + 2*v[x]*u*w^2 + 2*v[x]*u*w + u*v^2*w[x] + 4*u*v*w[x]*w + 3*u*v*w[x])/(v^7*w^2 + 2*v^7*w + v^7 + 4*v^6*w^3 + 8*v^6*w^2 + 4*v^6*w + 6*v^5*w^4 + 12*v^5*w^3 + 6*v^5*w^2 + 4*v^4*w^5 + 8*v^4*w^4 + 4*v^4*w^3 + v^3*w^6 + 2*v^3*w^5 + v^3*w^4)")
      == 0;

  ba0_sscanf2 ("u*a + (v[x,x]*v - v[x]^2)/v^2, x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &bav_global.parameters);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "v[x]/(v), u*a") == 0;

  ba0_sscanf2 ("u[x,x]^2 + (v[x,x]*v - v[x]^2)/(v^2*a), x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &bav_global.parameters);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "v[x]/(v*a), u[x,x]^2") == 0;

  ba0_sscanf2 ("u[x]*v[x] + u[x]*w[x] + a/4, x", "%Qz, %y", &Q, &x);
  baz_rat_bilge_mpz (&R, &W, &Q, x, &bav_global.parameters);
  ba0_sprintf (buffer, "%Qz, %Qz", &R, &W);
  b = b && strcmp (buffer, "(4*u*w[x] + a*x)/(4), u[x]*v[x] - u*w[x,x]") == 0;

  bav_R_pull_ordering ();
  baz_terminate (ba0_init_level);
  return b ? 0 : 1;
}
