#include "baz.h"

int
main (
    int argc,
    char **argv)
{
  struct baz_ratfrac R, A, result;
  struct baz_point_ratfrac point;
  struct bav_tableof_variable nulles;

  bav_Iordering r;
  struct ba0_table blks;
  struct ba0_tableof_string ders, pars;
  ba0_int_p timelimit;
  FILE *f;
  volatile bool b = true;
  char nota[64];
  static char buffer[32768], expected[32768];
/*
 * Are we able to open the file?
 */
  if (argc != 2)
    {
      fprintf (stderr, "error: missing filename on command line\n");
      return 1;
    }
  f = fopen (argv[1], "r");
  if (f == NULL)
    {
      fprintf (stderr, "error: unable to open %s\n", argv[1]);
      return 1;
    }
/*
 * First read timelimit
 */
  baz_restart (0, 0);
  BA0_TRY
  {
    ba0_set_input_FILE (f);
    ba0_get_token_analex ();
    ba0_scanf ("timelimit = %d", &timelimit);
  }
  BA0_CATCH
  {
    fprintf (stderr, "missing timelimit on first line\n");
    exit (1);
  }
  BA0_ENDTRY;
  baz_terminate (ba0_init_level);
/*
 * Then restart blad with this timelimit
 */
  baz_restart (timelimit, 0);

  BA0_TRY
  {
    ba0_set_input_FILE (f);
/*
 * R = DifferentialRing (...)
 */
    ba0_init_table (&blks);
    ba0_init_table ((struct ba0_table *) &pars);
    ba0_init_table ((struct ba0_table *) &ders);

    ba0_get_token_analex ();
    ba0_scanf
        ("R = DifferentialRing (blocks = %t[%b], parameters = %t[%six], derivations = %t[%s], notation = %s)",
        &blks, &pars, &ders, nota);
/*
 * Do not bother with nota
 */
    bav_set_settings_variable (&bav_scanf_maple_all_variable, 0, 0, 0, 0);
    bav_set_settings_rank (&bav_printf_stars_rank);
/*
 * The ordering
 */
    ba0_sprintf (buffer,
        "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering",
        "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_global.parameters, &pars);
/*
 * point = %point{%Qz}
 */
    ba0_get_token_analex ();
    ba0_init_point ((struct ba0_point *) &point);
    ba0_scanf ("point = %point{%Qz}", &point);
/*
 * A = %Qz
 */
    ba0_get_token_analex ();
    baz_init_ratfrac (&A);
    ba0_scanf ("A = %Qz", &A);
/*
 * go
 */
    ba0_get_token_analex ();
    ba0_scanf ("evaluate_ratfrac (A, point)");
    baz_init_ratfrac (&R);
    ba0_init_table ((struct ba0_table *) &nulles);
    bav_zero_derivatives_of_tableof_parameter (&nulles, &bav_global.parameters);
    baz_evaluate_to_ratfrac_at_point_ratfrac_ratfrac (&R, &A, &point, &nulles);
/*
 * Print the computed result 
 */
    ba0_printf ("%Qz\n", &R);
/*
 * Read the expected result in expected and check
 */
    ba0_get_token_analex ();
    baz_init_ratfrac (&result);
    ba0_scanf ("result = %Qz", &result);

    fclose (f);

    ba0_sprintf (expected, "%Qz", &result);
    ba0_sprintf (buffer, "%Qz", &R);

    b = strcmp (buffer, expected) == 0;
  }
  BA0_CATCH
  {
    if (ba0_global.exception.raised != BA0_ERRALR)
      BA0_RE_RAISE_EXCEPTION;
    fprintf (stderr, "Timelimit %d expired\n", (int) timelimit);
    b = false;
  }
  BA0_ENDTRY;

  baz_terminate (ba0_init_level);
  return b ? 0 : 1;
}
