#include "baz.h"

int
main (
    void)
{
  bav_Iordering r;
  struct baz_tableof_rel_ratfrac T;
  struct baz_rel_ratfrac Q;
  char buffer[256];

  baz_restart (0, 0);
  ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [u, v])",
      "%ordering", &r);
  bav_R_push_ordering (r);

  baz_init_rel_ratfrac (&Q);

  ba0_sscanf2 ("0", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "0") != 0)
    return 1;

  ba0_sscanf2 ("1 == v", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "1 == v") != 0)
    return 1;

  ba0_sscanf2 ("2/3/u != u", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "2/(3*u) != u") != 0)
    return 1;

  ba0_sscanf2 ("1/2*u[x,x] + u[x] + 1/2*u >= 0", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "(u[x,x] + 2*u[x] + u)/(2) >= 0") != 0)
    return 1;

  ba0_sscanf2 ("1/2*(u[x,x]+4*u[x]+u)/v < u[x]+u", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "(u[x,x] + 4*u[x] + u)/(2*v) < u[x] + u") != 0)
    return 1;
  ba0_sscanf2 ("0 <= (u[x]*u[y] + v)/(u[y])", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "0 <= (u[x]*u[y] + v)/(u[y])") != 0)
    return 1;
  ba0_sscanf2 ("-3/4*u[x]/u[y] > 3/4", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "-3*u[x]/(4*u[y]) > 3/(4)") != 0)
    return 1;

  ba0_sscanf2 ("1/u <> 5", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "1/(u) != 5") != 0)
    return 1;

  ba0_sscanf2 ("1/u = 5", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "1/(u) == 5") != 0)
    return 1;

  ba0_sscanf2 ("Eq(1/u,5)", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "1/(u) == 5") != 0)
    return 1;

  ba0_sscanf2 ("Ne(1/u,5)", "%relQz", &Q);
  ba0_sprintf (buffer, "%relQz", &Q);
  if (strcmp (buffer, "1/(u) != 5") != 0)
    return 1;

/*
 * Fix me
    ba0_sscanf2 ("2/u*u[x]", "%relQz", &Q);
    ba0_sprintf (buffer, "%relQz", &Q);
    if (strcmp (buffer, "2*u[x]/(u)") != 0)
        return 1;
*/

  ba0_init_table ((struct ba0_table *) &T);
  ba0_sscanf2 ("[1/u <> 5, 1/u = 5, 1/2*u[x,x] + u[x] + 1/2*u >= 0]",
      "%t[%relQz]", &T);
  ba0_sprintf (buffer, "%t[%relQz]", &T);
  if (strcmp (buffer,
          "[1/(u) != 5, 1/(u) == 5, (u[x,x] + 2*u[x] + u)/(2) >= 0]") != 0)
    return 1;

  bav_set_settings_variable
      (&bav_scanf_python_D_variable, &bav_printf_diff_variable, 0, 0, 0);
  ba0_sscanf2 ("[D[0, 1](u)(x, y)*D[1](v)(x, y) - u(x, y) + 1 == 0]",
      "%t[%relQz]", &T);
  ba0_sprintf (buffer, "%t[%relQz]", &T);
  if (strcmp (buffer,
          "[diff (u(x,y), x, y)*diff (v(x,y), y) - u(x,y) + 1 == 0]") != 0)
    return 1;


  bav_R_pull_ordering ();
  baz_terminate (ba0_init_level);
  return 0;
}
