#include "baz.h"

int
main (
    int argc,
    char **argv)
{
  struct bav_point_int_p point, result;
  struct bap_tableof_polynom_mpz nonzero;
  struct bap_product_mpz prod;
  struct bav_variable *avoid;

  bav_Iordering r;
  struct ba0_table blks;
  struct ba0_tableof_string ders, pars;
  ba0_int_p timelimit;
  FILE *f;
  volatile bool b = true;
  char nota[64];
  static char buffer[32768], expected[32768];
/*
 * Are we able to open the file?
 */
  if (argc != 2)
    {
      fprintf (stderr, "error: missing filename on command line\n");
      return 1;
    }
  f = fopen (argv[1], "r");
  if (f == NULL)
    {
      fprintf (stderr, "error: unable to open %s\n", argv[1]);
      return 1;
    }
/*
 * First read timelimit
 */
  baz_restart (0, 0);
  BA0_TRY
  {
    ba0_set_input_FILE (f);
    ba0_get_token_analex ();
    ba0_scanf ("timelimit = %d", &timelimit);
  }
  BA0_CATCH
  {
    fprintf (stderr, "missing timelimit on first line\n");
    exit (1);
  }
  BA0_ENDTRY;
  baz_terminate (ba0_init_level);
/*
 * Then restart blad with this timelimit
 */
  baz_restart (timelimit, 0);

  BA0_TRY
  {
    ba0_set_input_FILE (f);
/*
 * R = DifferentialRing (...)
 */
    ba0_init_table (&blks);
    ba0_init_table ((struct ba0_table *) &pars);
    ba0_init_table ((struct ba0_table *) &ders);

    ba0_get_token_analex ();
    ba0_scanf
        ("R = DifferentialRing (blocks = %t[%b], parameters = %t[%six], derivations = %t[%s], notation = %s)",
        &blks, &pars, &ders, nota);
/*
 * Do not bother with nota
 */
    bav_set_settings_variable (&bav_scanf_maple_all_variable, 0, 0, 0, 0);
    bav_set_settings_rank (&bav_printf_stars_rank);
/*
 * The ordering
 */
    ba0_sprintf (buffer,
        "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering",
        "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_global.parameters, &pars);
/*
 * point = %t[%value(%d)]
 */
    ba0_init_point ((struct ba0_point *) &point);
    ba0_get_token_analex ();
    ba0_scanf ("point = %t[%value(%d)]", &point);
/*
 * nonzero = %t[%Az]
 */
    ba0_init_table ((struct ba0_table *) &nonzero);
    ba0_get_token_analex ();
    ba0_scanf ("nonzero = %t[%Az]", &nonzero);
/*
 * prod = %Pz
 */
    bap_init_product_mpz (&prod);
    ba0_get_token_analex ();
    ba0_scanf ("prod = %Pz", &prod);
/*
 * avoid = %v
 */
    ba0_get_token_analex ();
    ba0_scanf ("avoid = %v", &avoid);
/*
 * go
 */
    ba0_get_token_analex ();
    ba0_scanf ("yet_another_point_int_p (point, nonzero, prod, avoid)");
    baz_yet_another_point_int_p_mpz (&point, &nonzero, &prod, avoid);
/*
 * Print the computed result 
 */
    ba0_printf ("%t[%value(%d)]\n", &point);
/*
 * Read the expected result in expected and check
 */
    ba0_init_point ((struct ba0_point *) &result);
    ba0_get_token_analex ();
    ba0_scanf ("result = %t[%value(%d)]", &result);

    fclose (f);

    ba0_sprintf (expected, "%t[%value(%d)]", &result);
    ba0_sprintf (buffer, "%t[%value(%d)]", &point);

    b = strcmp (buffer, expected) == 0;
  }
  BA0_CATCH
  {
    if (ba0_global.exception.raised != BA0_ERRALR)
      BA0_RE_RAISE_EXCEPTION;
    fprintf (stderr, "Timelimit %d expired\n", (int) timelimit);
    b = false;
  }
  BA0_ENDTRY;

  baz_terminate (ba0_init_level);
  return b ? 0 : 1;
}
