# Local function, called by 
# - RosenfeldGroebner,
# - EssentialComponents
# - Indets
#
#
# BaseField (undefined)
# BaseField (field (generators = list_of_generators, relations = regchain))
#
# Returns: list_of_generators, 'regchain' (list_of_polys, list_of_attributes)
#
# The returned regchain is in expanded form, not in internal form
#
# list_of_generators = [] if omitted
# regchain = 'regchain' ([], []) if omitted

BaseField := proc (basefield)
    local gens, rels;

    if basefield = ':-_U_' then
	gens := [];
	rels := 'regchain' ([], []);
    elif op (0, basefield) != ':-field' or
		nops (basefield) > 2  or
		not type ([op (basefield)], ':-list(:-relation)') or
		not map (lhs, { op (basefield) }) subset
					{':-generators', ':-relations'} then
	error _ERRBAS_
    else
	gens := subs (op (basefield), ':-generators');
	rels := subs (op (basefield), ':-relations');
	if gens <> ':-generators' and not type (gens, ':-list') then
	    error _ERRBAS_
	elif rels <> ':-relations' and 
				not IsRegularDifferentialChain (rels) then
	    error _ERRBAS_
	end if;
	if gens = ':-generators' then
	    gens := []
	end if;
	if rels = ':-relations' then
	    rels := 'regchain' ([], [])
	else
	    rels := 'regchain' (Equations (rels), Attributes (rels))
	end if
    end if;
    return gens, rels;
end proc:

