# LOCAL function

# This function somehow "undoes" the work of ToExpandedRatfracList
#
# Converts data (which is assumed to be a list) to the same type of object 
# as model:
#
# if model is a list, data is kept as is
# if model is a set, data is converted to a set
# if model is not a list nor a set, takes the first (only) element of data

FromExpandedRatfracList := proc (data, model)
    local result;
    if type (model, '{:-algebraic,:-equation}') then
        result := op (data);
    elif type (model, ':-list') then
        result := data;
    elif type (model, ':-set') then
        result := convert (data, ':-set');
    else
        error
    end if;
    return result;
end proc:
