# LOCAL function

# Returns true if ideal is a regchain or a list of regchains
# The list may of may not be empty, depending on the boolean
#
# This function does not check that the regchains belong to
# the same differential ring.

IsIdeal := proc (ideal, {possibly_empty::boolean:=true})
    local i, result;
    if type (ideal, ':-table') then
        result := evalb (ideal [':-_TYPE_'] = ':-_REGCHAIN_')
    elif type (ideal, ':-list(:-table)') and 
                            (possibly_empty or nops (ideal) > 0) then
        result := true;
        for i from 1 to nops (ideal) do
            if ideal [i][':-_TYPE_'] <> ':-_REGCHAIN_' then
                result := false;
            end if;
        end do
    else
        result := false;
    end if;
    return result;
end proc:

