#test
# The academic PDE example from the PARDI paper
# Return ticket using PARDI

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# First ranking

Try[testnoerror] (10, DifferentialRing (derivations = [x,y], blocks = [[v,u]]), assign='S');

Try[testnoerror] (20, RosenfeldGroebner ([u[x]^2-4*u = 0, u[x,y]*v[y]-u+1 = 0, v[x,x]-u[x] = 0], S), assign='ideal');

Try (30, nops (ideal), 1);

Try[testnoerror] (40, ideal[1], assign='ideal');

Try[testnoerror] (50, Equations (ideal), assign='eqns');

Try (60, eqns, [u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y], v[x,x]-u[x]]);

# Second ranking, using PARDI

Try[testnoerror] (70, Pardi (ideal, ranking (derivations = [x,y], blocks = [[u,v]]), prime=true), assign='jdeal');

Try (80, Equations (jdeal), [2*v[y]^2-u^2+2*u-1, u[y]^2-2*u, u[x]*u-u[x]-2*u[y]*v[y], v[x,x]*u-v[x,x]-2*u[y]*v[y]]);

# Back to the first ranking, using PARDI
# The prime attribute should be set.

Try[testnoerror] (90, Pardi (jdeal, S), assign='kdeal');

Try (100, Equations (kdeal), eqns);

#end test
