#test
# Tests the Attributes function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Algebraic case
Try[testnoerror] (10, DifferentialRing (derivations = [], blocks = [u]), assign='R');

# Default values
Try[testnoerror] (20, RosenfeldGroebner ([u], R), assign='ideal');
Try (30, Attributes (ideal), [[prime, autoreduced, primitive, squarefree, normalized]]);

Try (40, Attributes (R), [autoreduced, primitive, squarefree, normalized]);

# The zero ideal is not prime
Try[testnoerror] (50, RosenfeldGroebner ([], R, attributes = []), assign='ideal');
Try (60, Attributes (ideal), [[]]);

# Imposed values
Try[testnoerror] (70, RosenfeldGroebner ([u], R, attributes = []), assign='ideal');
Try (80, Attributes (ideal), [[prime]]);

# Filtering

Try[testnoerror] (90, RosenfeldGroebner ([u], R, attributes = [differential]), assign='ideal');
Try (100, Attributes (ideal), [[prime]]);

# ODE case

Try[testnoerror] (110, DifferentialRing (derivations = [t], blocks = [u]), assign='R');

# Default values
Try[testnoerror] (120, RosenfeldGroebner ([u], R), assign='ideal');
Try (130, Attributes (ideal), [[differential, prime, autoreduced, primitive, squarefree, normalized]]);

Try (140, Attributes (R), [differential, autoreduced, primitive, squarefree, normalized]);

# Imposed values
Try[testnoerror] (150, RosenfeldGroebner ([u], R, attributes = []), assign='ideal');
Try (160, Attributes (ideal), [[prime]]);

Try[testnoerror] (170, RosenfeldGroebner ([u], R, attributes = [differential]), assign='ideal');
Try (180, Attributes (ideal), [[differential, prime, squarefree]]);

Try[testnoerror] (190, RosenfeldGroebner ([u], R, attributes = [differential, coherent]), assign='ideal');
Try (200, Attributes (ideal), [[differential, prime, squarefree]]);

# PDE case

Try[testnoerror] (210, DifferentialRing (derivations = [t,s], blocks = [u]), assign='R');

Try[testnoerror] (220, RosenfeldGroebner ([u], R), assign='ideal');
Try (230, Attributes (ideal), [[differential, prime, autoreduced, primitive, squarefree, coherent, normalized]]);

Try (240, Attributes (R), [differential, autoreduced, primitive, squarefree, coherent, normalized]);

Try[testnoerror] (250, RosenfeldGroebner ([u], R, attributes = [differential]), assign='ideal');
Try (260, Attributes (ideal), [[differential, prime, squarefree, coherent]]);

#end test
