#test
# Tests the BelongsTo function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, DifferentialRing (derivations = [t], blocks = [u]), assign='R');

# The Unit ideal

Try (20, BelongsTo (u, []), true);

Try (30, DifferentialAlgebra0:-BelongsTo ([a,b], []), [true, true]);

# The zero ideal

Try[testnoerror] (40, PretendRegularDifferentialChain ([], R), assign='zero');

Try (50, BelongsTo (0, zero), true);

Try (60, BelongsTo (u, zero), false);

# General case

Try[testnoerror] (70, RosenfeldGroebner ([u[t]^2-4*u], R), assign='ideal');

# W.r.t. lists

Try (80, BelongsTo (u[t], ideal), false);
Try (90, BelongsTo (u[t,t]-2, ideal), false);
Try (100, BelongsTo (u[t]*(u[t,t]/2-1), ideal), true);

# simple tables

Try (110, BelongsTo (u[t], ideal[1]), false);
Try (120, BelongsTo (u[t], ideal[2]), true);

# equations

Try (130, BelongsTo (u[t]=0, ideal[1]), false);

#end test
