#test
# Tests the coeffs function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, DifferentialRing (derivations = [x,y], blocks = [[v,u]]), assign='R');

# Special cases

Try (20, [Coeffs (0, u, R)], [[], []]);

Try (30, [Coeffs (421, u, R)], [[421], [1]]);

# With equations

Try (40, [Coeffs (v=u, v, R)], [[1, -u], [v, 1]]);

# On basic normal forms

Try (50, [Coeffs (1/4*(u[x]*u[y]*u-u[x]*u[y])/u, u, R)], 
		[[1/4, -1/4], [u[x]*u[y], u[x]*u[y]/u]]);

Try (60, [Coeffs (1/4*(u[x]*u[y]*u-u[x]*u[y])/u, u[x], R)],
		[[1/4*(u[y]*u-u[y])/u], [u[x]]]);

Try (70, [Coeffs (1/4*(u[x]*u[y]*u-u[x]*u[y])/u, u[x,x], R)],
		[[1/4*(u[x]*u[y]*u-u[x]*u[y])/u], [1]]);

# The diff notation

Try (80, [Coeffs (1/4*(diff(u(x,y),x)*diff(u(x,y),y)*u(x,y)-diff(u(x,y),x)*diff(u(x,y),y))/u(x,y), u(x,y), R, notation=diff)], [[1/4, -1/4], [diff(u(x,y),x)*diff(u(x,y),y), diff(u(x,y),x)*diff(u(x,y),y)/u(x,y)]]);

# On Kaehler differentials

Try[testnoerror] (90, DifferentialRing (derivations = [x,y], blocks = [[d(v),d(u)],[v,u]]), assign='dR');

Try[testnoerror] (100, 1/4*(d(u)[y,y]*u[x]*u^2-d(u)[y,y]*u[x]*u-d(u)[y]*u[x]*u[y]*u+d(u)[y]*u[x]*u[y]-d(u)*u[x])/u^2, assign='nf');

Try (110, [Coeffs (nf, d(u), dR)], [[1/4*(u[x]*u-u[x])/u, 1/4*(-u[x]*u[y]*u+u[x]*u[y])/u^2, -1/4*u[x]/u^2], [d(u)[y,y], d(u)[y], d(u)]]);

# W.r.t an ideal

Try[testnoerror] (120, [u[x]^2-4*u, u[x,y]*v[y] - u + 1, v[x,x] - u[x]], assign='syst');

Try[testnoerror] (130, RosenfeldGroebner (syst, R)[1], assign='ideal');

Try (140, [Coeffs (1/4*(u[x]*u[y]*u-u[x]*u[y])/u, u, ideal)],
                [[1/4, -1/4], [u[x]*u[y], u[x]*u[y]/u]]);

Try (150, [Coeffs (1/4*(u[x]*u[y]*u-u[x]*u[y])/u, u[x], ideal)],
                [[1/4*(u[y]*u-u[y])/u], [u[x]]]);

Try (160, [Coeffs (1/4*(u[x]*u[y]*u-u[x]*u[y])/u, u[x,x], ideal)],
                [[1/4*(u[x]*u[y]*u-u[x]*u[y])/u], [1]]);

#end test
