#test
# Tests the DifferentialPrem function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, DifferentialRing (derivations = [x,y], blocks = [[v,u]]), assign='R');

Try[testnoerror] (20, [u[x]^2=4*u, u[x,y]*v[y]-u+1, v[x,x]-u[x]], assign='syst');

Try[testnoerror] (30, RosenfeldGroebner (syst, R)[1], assign='ideal');

Try (40, [DifferentialPrem (u[x,y], ideal)], [2*u[y], 2*u[x]]);

Try (50, [DifferentialPrem (u[x,y], syst, R)], [2*u[x], 4*u[y]]);

Try (60, [DifferentialPrem (u[x,y], syst, R, reduction=full)], [2*u[x], 4*u[y]]);

Try (70, [DifferentialPrem ((1/7)*u[x,y], syst, R, reduction=full)], [2*u[x], 4/7*u[y]]);

Try (80, [DifferentialPrem (u[x]^3, syst, R, reduction=partial)], [1, u[x]^3]);

# Bug fix June 2010
Try (90, [DifferentialPrem (u[x,y] + u[x]^3, syst, reduction=algebraic, R)],  [v[y], 4*v[y]*u[x]*u + u - 1]);

Try (100, [DifferentialPrem (u[x,y] = - u[x]^3, syst, reduction=algebraic, R)], [v[y], 4*v[y]*u[x]*u + u - 1]);

Try (110, [DifferentialPrem (diff(u(x,y),x,y) = - diff (u(x,y),x)^3, [], reduction=algebraic, input=diff, R)], [1, u[x,y] + u[x]^3]);

Try (120, [DifferentialPrem (u[x,x], u[x]^2-4*u, R, reduction=full)], [2*u[x], 4*u[x]]); 

# Revealed a bug.

Try[testnoerror] (130, DifferentialRing (derivations = [x], blocks = [y,z]), assign='R');

Try[testnoerror] (140, [DifferentialPrem (y*y[x], [x*y^2 + x^2*z[x]], R)], assign='res');
#end test
