#test
# Tests the Differentiate function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, DifferentialRing (derivations=[x,y], blocks=[[v,u],p], parameters=[p]), assign='R');

Try (20, Differentiate (1, R), 1);
Try (30, Differentiate (1, 1, R), 1);
Try (40, Differentiate (1, x, R), 0);

Try (50, Differentiate (u, R, output=Diff), u(x,y));
Try (60, Differentiate (u, 1, R, output=Diff), u(x,y));
Try (70, Differentiate (u, y, R, output=Diff), Diff(u(x,y),y));
Try (80, Differentiate (u, y, x, y, R, output=tjet), u[x,y,y]);
Try (90, Differentiate (u, x*y^2, R, output=tjet), u[x,y,y]);

Try (100, Differentiate ([u, p], R), [u, p]);
Try (110, Differentiate ([u, p], 1, R), [u, p]);
Try (120, Differentiate ([u, p], x, R), [u[x], 0]);
Try (130, Differentiate ({u, p}, x, x, y, x, R), {u[x,x,x,y], 0});
Try (140, Differentiate ({u, p}, x^2, y*x, R), {u[x,x,x,y], 0});

# W.r.t an ideal

Try[testnoerror] (150, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+p, v[x,x]-u[x]], R), assign='ideal');

Try (160, Differentiate (1, ideal), 1);
Try (170, Differentiate (1, 1, ideal), 1);
Try (180, Differentiate (1, x, ideal), 0);

Try (190, Differentiate (u, ideal, output=Diff), u(x,y));
Try (200, Differentiate (u, 1, ideal, output=Diff), u(x,y));
Try (210, Differentiate (u, y, ideal, output=Diff), Diff(u(x,y),y));
Try (220, Differentiate (u, y, x, y, ideal, output=tjet), u[x,y,y]);
Try (230, Differentiate (u, x*y^2, ideal, output=tjet), u[x,y,y]);

Try (240, Differentiate ([u, p], ideal), [u, p]);
Try (250, Differentiate ([u, p], 1, ideal), [u, p]);
Try (260, Differentiate ([u, p], x, ideal), [u[x], 0]);
Try (270, Differentiate ({u, p}, x, x, y, x, ideal), {u[x,x,x,y], 0});
Try (280, Differentiate ({u, p}, x^2, y*x, ideal), {u[x,x,x,y], 0});

# Equations

Try (290, Differentiate (u = 0, x*y^2, ideal, output=tjet), u[x,y,y]);

# differentiation of rational fractions

Try[testnoerror] (300, DifferentialRing (R, notation=diff), assign='R');

Try[testnoerror] (310, 1/2*diff(u(x,y),x)*diff(u(x,y),y)/u(x,y), assign='nf');

Try (320, Differentiate (Differentiate (nf, x, R) - diff (nf, x), R), 0);
Try (330, Differentiate (Differentiate (nf, y, y, R) - diff (nf, y, y), R), 0);

# differentiate (ideal)

Try (340, Differentiate ([]), []);

Try (350, Differentiate (ideal), [[u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]], [p, u, v[x,x]]]);

Try (360, Differentiate (ideal, x), [[2*u[x,y]*u[y]-2*u[x], 2*u[x,x]*u[x]-4*u[x], 4*v[x,y]*u-u[x,x]*u[y]*u+u[x,x]*u[y]*p-u[x,y]*u[x]*u+u[x,y]*u[x]*p+4*v[y]*u[x]-u[x]^2*u[y], v[x,x,x]-u[x,x]], [0, u[x], v[x,x,x]]]);

Try (370, Differentiate (ideal[2], y^2), [0, u[y,y], v[x,x,y,y]]);
#end test
