#test
# Tests the DifferentialRing function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] 
	(10, DifferentialRing (derivations = [t], blocks = [u]), assign='R');

Try (20, type (R, table), true);


# No derivations

Try[testnoerror]
	(30, DifferentialRing (derivations = [], blocks = [u]), assign='R');

Try (40, type (R, table), true);


# notation and parameters
R := NULL:
Try[testnoerror]
	(50, DifferentialRing (derivations = [t], blocks = [u,[v,w]], 
		notation = diff, parameters = [v]), assign='R');

Try (60, type (R, table), true);


# DifferentialRing (DRing)
Try[testnoerror]
	(70, DifferentialRing (R, notation = jet), assign='S');

Try (80, type (S, table), true);


# DifferentialRing (ideal)
# RosenfeldGroebner (empty list)
Try[testnoerror] (90, RosenfeldGroebner ([], S), assign='ideal');

Try[testnoerror] (100, DifferentialRing (ideal[1]), assign='T');

Try (110, type (T, table), true);

# Getting rid of empty blocks
Try[testnoerror] (120, DifferentialRing (derivations = [t], blocks = [u, [], v]), assign='R');

Try (130, Ranking(R), ranking(derivations = [t], blocks = [grlexA[u], grlexA[v]]));

#end test
