#test

# Tests the Equations function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# The unit ideal
Try (10, Equations ([]), []);

# Parameters in order to test the fullset=true option
Try[testnoerror]
        (20, DifferentialRing (derivations = [t], blocks = [u,p], 
				parameters = [p]), assign='R');
Try[testnoerror]
	(30, RosenfeldGroebner ([u[t]^2 = p*u], 
				basefield = field (generators = [p]), R),
				assign='ideal');

Try (40, Equations (ideal), [[u[t]^2 - p*u], [u]]);

Try (50, Equations (ideal, fullset=true), [[p[t], u[t]^2 - p*u], [p[t], u]]);

# Selection criteria
Try[testnoerror]
        (60, DifferentialRing (derivations=[x,y], blocks=[[v,u]]),
				assign='R');
Try[testnoerror]
	(70, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+1, v[x,x]-u[x]], R),
				assign='ideal');

# The zero ideal

Try (80, Equations (RosenfeldGroebner ([], R)[1]), []);

# The empty lists and sets

Try (90, Equations ([], R), []);

Try (100, Equations ({}, R), {});

# Double list
Try (110, Equations (ideal), [[u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y], v[x,x]-u[x]]]);

# Simple list
Try[testnoerror] (120, ideal[1], assign='ideal');

Try (130, Equations (ideal), [u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y], v[x,x]-u[x]]);

# Selection in a regchain
Try (140, Equations (ideal, leader=v[x,x]), [v[x,x] - u[x]]);

# Selection in a list
Try (150, Equations (Equations (ideal), leader=v[x,x], R), [v[x,x] - u[x]]);

Try (160, Equations ([0, 17, v[x]], R), [0, 17, v[x]]);

# With a single polynomial

Try (170, Equations (u, R), u);

Try (180, Equations (u, order >= 1, R), NULL);

# Selection in a set
Try (190, Equations ({u[y]^2=2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y], v[x,x]-u[x]}, leader=v[x,x], R), {v[x,x] - u[x]});

Try (200, Equations (Equations (ideal), leader<>v[x,x], R), [u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]]);

Try (210, Equations (ideal, leader=u), []);

Try (220, Equations (ideal, leader=derivative(u)), [u[y]^2-2*u, u[x]^2-4*u]);

Try (230,  Equations (ideal, leader<>derivative(u)), [4*v[y]*u-u[x]*u[y]*u+u[x]*u[y], v[x,x] - u[x]]);

Try (240,  Equations (ideal, leader=proper(u)), [u[y]^2-2*u, u[x]^2-4*u]);

Try (250, Equations (ideal, leader>v[y]), [v[x,x] - u[x]]);

Try (260, Equations (ideal, leader>=v[y]), [4*v[y]*u-u[x]*u[y]*u+u[x]*u[y], v[x,x]-u[x]]);

Try (270, Equations (ideal, leader<v[y]), [u[y]^2-2*u, u[x]^2-4*u]);

Try (280, Equations (ideal, leader<=v[y]), [u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]]);

Try (290,  Equations ([u[x]^2=4*u], rank = u[x]^2, ideal), [u[x]^2-4*u]);

Try (300,  Equations ([u[x]^2-4*u], rank = u[x], ideal), []);

Try (310, Equations ([3, u[x]^2-4*u, 0, v[x,x]], rank>=0, ideal), [3, u[x]^2-4*u, 0, v[x,x]]);

Try (320,  Equations ([3, u[x]^2-4*u, 0, v[x,x]], rank>=1, ideal), [3, u[x]^2-4*u, v[x,x]]);

Try (330, Equations ([3, u[x]^2-4*u, 0, v[x,x]], rank<u, ideal), [3, 0]);

Try (340, Equations (ideal, order=1), [u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]]);

Try (350, Equations (ideal, order>1), [v[x,x] - u[x]]);

Try (360, Equations (ideal, order<1), []);

Try (370, Equations (ideal, order<=1), [u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]]);

Try (380, Equations
        ({u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]}, order=1, R),
	 {u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]});

Try (390, Equations (ideal, order>=1), Equations (ideal));

Try (400, Equations (ideal, leader>v[y], output=diff),
		[diff(diff(v(x,y),x),x)-diff(u(x,y),x)]);

Try[testnoerror] (410, Equations (ideal, output=diff), assign='eqns');
Try (420, Equations (eqns, leader=diff(v(x,y),x,x), R, input=diff), [v[x,x] - u[x]]);

Try (430, Equations ([u[x,y]*v[y]-u+1, v[x,x]-u[x], u[x]^2-4*u], R),
		[u[x,y]*v[y]-u+1, v[x,x]-u[x], u[x]^2-4*u]);

#end test
