#test
# Tests the EssentialComponents function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, DifferentialRing (derivations = [t], blocks = [u]), assign='R');

Try[testnoerror] (20, EssentialComponents (u[t]^2-4*u, R), assign='ideal');

Try (30, Equations (ideal), [[u[t]^2-4*u], [u]]);

Try[testnoerror] (40, EssentialComponents (u[t]^2=4*u, R), assign='ideal');

Try (50, Equations (ideal), [[u[t]^2-4*u], [u]]);

Try[testnoerror] (60, EssentialComponents (u[t]^2-4*u^3, R), assign='ideal');

Try (70, Equations (ideal), [[u[t]^2-4*u^3]]);

# This example produces splittings over some components returned by RG.

Try[testnoerror] (80, EssentialComponents (u[t,t]^2+2*u[t,t]*u[t]*u^3-4*u[t]^3*u^2, R), assign='ideal');

Try (90, Equations (ideal), [[u[t,t]^2+2*u[t,t]*u[t]*u^3-4*u[t]^3*u^2], [4*u[t]+u^4]]);

# With parameters

Try[testnoerror] (100, DifferentialRing (derivations = [t], blocks = [u,p], parameters = [p]), assign='R');

Try[testnoerror] (110, EssentialComponents (u[t]^2-p*u, basefield=field(generators=[p]), R), assign='ideal');

Try (120, Equations (ideal), [[u[t]^2-p*u], [u]]);

Try[testnoerror] (130, EssentialComponents (u[t]^2-p*u^3, basefield=field(generators=[p]), R), assign='ideal');

Try (140, Equations (ideal), [[u[t]^2-p*u^3]]);

# With a non trivial base field

Try[testnoerror] (150, DifferentialRing (derivations = [t], blocks = [u,[s,c]]), assign='R');

Try[testnoerror] (160, RosenfeldGroebner ([s[t] - c, c[t] + s], R) [1], assign='kdeal');

Try[testnoerror] (170, EssentialComponents (u[t]^2-s*u, output=diff, basefield=field(relations=kdeal), R), assign='ideal');

Try (180, Equations (ideal), [[diff(c(t),t)+s(t), diff(s(t),t)-c(t), diff(u(t),t)^2-u(t)*s(t)], [diff(c(t),t)+s(t), diff(s(t),t)-c(t), u(t)]]);

# A variation of the Weierstrass P function
# EssentialComponents removes a prime ideal from one of the components.

Try[testnoerror] (190, DifferentialRing (notation = diff, derivations = [z], blocks = [w,g], parameters = [g]), assign='Rs');

Try[testnoerror] (200, diff(w(z),z)^2-4*w(z)^3+3*g^2*w(z)+g^3, assign='Wps');

Try (210, Equations (EssentialComponents (Wps, Rs, basefield=field(generators=[g]))), [[diff(w(z),z)^2-4*w(z)^3+3*g^2*w(z)+g^3], [w(z)-g]]);


#end test
