#test
# The DAE example of Hairer and Wanner, volume II.

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, 
	DifferentialRing (derivations = [t], blocks = [[s,c,x,y,z]]), 
	assign='R');

Try[testnoerror] (20, 
	[ diff (x(t),t) - 7/10*y(t) - s(t),
          diff (y(t),t) - 14/10*x(t) - c(t),
          x(t)^2 + y(t)^2 - 1,
          diff (s(t), t) - 25/10*diff (z(t),t)*c(t),
          diff(c(t),t) + 25/10*diff(z(t),t)*s(t),
          s(t)^2 + c(t)^2 - 1 ], assign='syst');

Try[testnoerror] (30, 
	RosenfeldGroebner (syst, R, input=diff),
	assign='ideal');

# The algebraic variety of the constraints
Try (40, LeadingRank (ideal [1]), [x^2, c^2, s, z[t], y[t]]);

# The missing ODE. It gives the underlying explicit system
Try (50, RewriteRules (ideal[1], leader=z[t]),
	[z[t] = -(-13230*c*x*y^4+14700*c*x*y^2-3940*c*x+12348*y^6-25809*y^4
			+16961*y^2-3500)/(11025*y^6-22050*y^4+13525*y^2-2500)]);

# Reformulation of dx/dt
Try (60,  NormalForm (x[t], ideal[1]), (5*c*x*y-7*y^3+7*y)/(5*y^2-5));

#end test
