#test
# Tests the Indets function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] 
	(10, DifferentialRing (derivations=[x,y], blocks=[[v,u],p], parameters = {p}), assign='R');

# Indets (DRing)

Try (20, Indets (R), {v,u,p});

Try (30, Indets (R, selection=allvars), {v,u,p,x,y});

Try (40, Indets (R, selection=allvars, output=diff), {p,x,y,u(x,y),v(x,y)});

Try (50, Indets (R, selection=parameters), {p});

Try (60, Indets (R, selection=indepvars), {x,y});

# Indets (polynomials)

Try (70, Indets (u[x]^2-4*y*u, R), {u, u[x]});

Try (80, Indets ([u[x]^2-4*y*u], R), {u, u[x]});

Try (90, Indets ({u[x]^2-4*y*u}, R), {u, u[x]});

Try (100, Indets (u[x]^2-4*y*u, selection = depvars, R),  {u});

Try (110, Indets (u[x]^2=4*y*u, selection = allvars, R), {y, u, u[x]});

Try (120, Indets (u[x]^2-4*y*u, selection = derivatives, R), {u, u[x]});

Try (130, Indets (u[x]^2-4*y*u, selection = indepvars, R),  {y});

# Indets (Rational fraction)

Try (140, Indets (diff(u(x,y),y)/v(x,y) = 1, R, input=diff), {u[y],v});

# Indets (ideal)

Try[testnoerror]
	(150, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+p, v[x,x]-u[x]], R),
	 assign='ideal');

Try (160, Indets ([]), {});

Try (170, Indets (RosenfeldGroebner ([], R)), [{}]);

Try (180, Indets (ideal), [{p, u, u[x], u[y], v[y], v[x, x]}, {p, u, v[x, x]}]);

Try (190, Indets (ideal, selection = parameters), [{p}, {p}]);

Try (200, Indets ([u[x]], ideal [1]), {u[x]});
Try (210, Indets ([u[x]], ideal), {u[x]});

# Indets (base field)

Try[testnoerror]
	(220, DifferentialRing (derivations = [t], blocks = [u,[v,w],[p,q]],
		parameters = [p,q]), assign = 'R');

Try[testnoerror]
	(230, PretendRegularDifferentialChain ([w[t]], R), assign='ideal');

Try (240, Indets (field (), R), {});
Try (250, Indets (field (), selection = allvars, R), {t});
Try (260, Indets (field (generators = [p, q]), R), {p, q});
Try (270, Indets (field (relations = ideal, generators = [v,p,q]), R), {v, w, p, q});
Try (280, Indets (field (relations = ideal, generators = [v,p,q]), selection = allvars, R), {v, w, p, q, t});
Try (290, Indets (field (relations = ideal, generators = [u,v,w,p,q]), R), {u, v, w, p, q});

# Indets (ideal, selection=iniconds(n))

Try[testnoerror]
        (300, DifferentialRing (derivations=[x,y], blocks=[[v,u],p,q], parameters = [p,q(x)]), assign = 'R');

Try[testnoerror]
        (310, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+p,v[x,x]-u[x]], R), assign='ideal');

Try (320, Indets (ideal, selection=iniconds(3)), [{p, q, u, v, q[x], q[x,x], q[x,x,x], v[x]}, {q, v, q[x], q[x,x], q[x,x,x], v[x], v[y], v[x,y], v[y,y], v[x,y,y], v[y,y,y]}]);

Try (330, Indets (ideal, selection=iniconds(3), output=diff), 
[{p, q(x), u(x,y), v(x,y), diff(q(x),x), diff(v(x,y),x), diff(diff(q(x),x),x),
 diff(diff(diff(q(x),x),x),x)}, {q(x), v(x,y), diff(q(x),x), diff(v(x,y),x),
 diff(v(x,y),y), diff(diff(q(x),x),x), diff(diff(v(x,y),x),y), diff(diff(v(x,y)
 ,y),y), diff(diff(diff(q(x),x),x),x), diff(diff(diff(v(x,y),x),y),y), diff(
 diff(diff(v(x,y),y),y),y)}]);

Try (340, Indets (ideal[1], selection=iniconds(3)), {p, q, u, v, q[x], q[x, x], q[x, x, x], v[x]});

Try (350, Indets (PretendRegularDifferentialChain ([], R), selection=iniconds(1)), {p, q, u, v, q[x], u[x], u[y], v[x], v[y]});

#end test
