#test
# Tests the Inequations function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, DifferentialRing (derivations = [x, y], blocks = [[v,u]]), assign='R');

# The unit ideal
Try (20, Inequations ([]), []);

# The zero ideal
Try (30, Inequations (PretendRegularDifferentialChain ([], R)), []);

Try[testnoerror] (40, RosenfeldGroebner ([x*u[x]-u, 3*v[y]^2 - 1], R), assign='ideal');

Try (50, Inequations (ideal), [[x, v[y]]]);
Try (60, Inequations (ideal [1]), [x, v[y]]);
Try (70, Inequations (ideal [1], output=diff), [ x, diff(v(x,y),y) ]);

# The diff notation

Try[testnoerror] (80, RosenfeldGroebner ([x*u[x]-u, 3*v[y]^2 - 1], R, output=diff), assign='ideal');
Try (90, Inequations (ideal), [[x, diff(v(x,y),y)]]);

#end test
