#test
# Tests the Initial function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use

Try[testnoerror] (10, DifferentialRing (notation = diff, derivations = [x,y],
                        blocks = [[v,u],k1,k2,k3], parameters = [k1,k2,k3]),
			assign='R');

Try (20, Initial (diff(u(x,y),x) + v(x,y)^2 = x + 2, R), 1);

Try (30, Initial (k1*diff(u(x,y),x) + k2*k3*v(x,y)*u(x,y) - k2 + x - 4, R), k1);

# Applied to lists and sets

Try[testnoerror] (40, DifferentialRing (derivations=[x,y], blocks=[[v,u],p], parameters=[p]), assign='R');

Try (50, Initial ([u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]], R), [1, 1, 4*u, 1]);

Try (60, Initial ({u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]}, R), {1, 1, 4*u, 1});

# The unit ideal

Try (70, Initial ([]), []);

# Other ideals

Try[testnoerror] (80, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+p, v[x,x]-u[x]], R), assign='ideal');

Try (90, Initial (ideal), [[1, 1, 4*u, 1], [1, 1, 1]]);

#end test
