#test
# Computation of an input-output relation on a chemical reaction system

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

Try[testnoerror] (10, [k[e], V[e], k[1,2], k[2,1]], assign='pars');

Try[testnoerror] (20, DifferentialRing (derivations = [t], blocks = [[x[1], x[2]], pars], parameters = pars, notation = diff), assign='R');

Try[testnoerror] (30, diff (x[1](t),t) =
			-k[1,2]*x[1](t) + k[2,1]*x[2](t) -
			(V[e]*x[1](t))/(k[e]+x[1](t)), assign='edoA');
Try[testnoerror] (40, diff (x[2](t),t) =
			k[1,2]*x[1](t) - k[2,1]*x[2](t), assign='edoB');

# The input system already is a regular differentialchain w.r.t. 
# the natural ranking

Try[testnoerror] (50, RosenfeldGroebner 
	([edoA,edoB], basefield = field (generators = pars), R),
			assign='ideal');

# Eliminate x1 using PARDI

Try[testnoerror] (60, Pardi (ideal[1], ranking (derivations = [t], blocks = [x[2], x[1], pars])), assign='IOideal');

Try[testnoerror] (70, Equations (IOideal, leader=derivative(x[1](t)))[1], assign='IOrel');

# The IO relation
Try[testnoerror] (80, (x[1](t)*V[e]*k[2,1])/(k[e]+x[1](t)) +
			Differentiate ((k[1,2]*x[1](t)^2 + x[1](t)^2*k[2,1] 
					+ (k[1,2]+k[2,1])*k[e]*x[1](t) 
					-k[e]*V[e])/(k[e]+x[1](t)), t, R) +
			Differentiate (x[1](t),t^2,R), assign='IOrel2');

Try (90, Differentiate (IOrel2 - IOrel / Initial (IOrel, R), R), 0);

#end test
