#test
# Tests the IsDifferentialRing function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# On a DRing
Try[testnoerror]
	(10, DifferentialRing (derivations = [x,y], blocks = [[v,u]]), assign='R');
Try (20, IsDifferentialRing (R), true);

# On a regchain by RG
Try[testnoerror]
	(30, [u[x]^2-4*u = 0, u[x,y]*v[y]-u+1, v[x,x] = u[x]], assign='syst');

Try[testnoerror] (40, RosenfeldGroebner (syst, R), assign='ideal');
Try[testnoerror] (50, ideal[1], assign='ideal');
Try (60, IsDifferentialRing (ideal), false);

# On a regchain by Pardi
Try[testnoerror] (70, Pardi (ideal, 
	ranking (derivations = [x,y], blocks = [[u,v]]), prime=true), assign='jdeal');
Try (80, IsDifferentialRing (jdeal), false);

# On a regchain by PretendRegularDifferentialChain
Try[testnoerror] (90, PretendRegularDifferentialChain ([u[x]^2-4*u], R), assign='kdeal');
Try (100, IsDifferentialRing (kdeal), false);

#end test
