#test
# Tests the LeadingCoefficient function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use

Try[testnoerror] (10, DifferentialRing (notation = diff, derivations = [x,y],
                        blocks = [[v,u],k1,k2,k3], parameters = [k1,k2,k3]),
			assign='R');

Try (20, LeadingCoefficient 
	(diff(u(x,y),x) + k1*v(x,y)^2 - x + 2, diff(u(x,y),x), R), 1);

Try (30, LeadingCoefficient 
	(diff(u(x,y),x) + k1*v(x,y)^2 - x + 2, diff(u(x,y),y,x), R), 
	 diff(u(x,y),x) + k1*v(x,y)^2 - x + 2);

Try (40, LeadingCoefficient 
	(diff(u(x,y),x) + k1*v(x,y)^2 = x - 2, diff(u(x,y),y,x), R), 
	 diff(u(x,y),x) + k1*v(x,y)^2 - x + 2);

Try (50, LeadingCoefficient 
	(diff(u(x,y),x) + k1*v(x,y)^2 - x + 2, v(x,y), R), k1);

# Applied to lists and sets

Try[testnoerror] (60, DifferentialRing (derivations=[x,y], blocks=[[v,u],p], parameters=[p]), assign='R');

Try (70, LeadingCoefficient ([u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]], u[x], R), [u[y]^2-2*u, 1, -u[y]*u+u[y]*p, -1]);

Try (80, LeadingCoefficient ({u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]}, u[x], R), {u[y]^2-2*u, 1, -u[y]*u+u[y]*p, -1});

# When no variable is given : it is the initial

Try (90, LeadingCoefficient ([u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]], R), Initial ([u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]], R));
 
# The unit ideal

Try (100, LeadingCoefficient ([], u[x]), []);

# Other ideals

Try[testnoerror] (110, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+p, v[x,x]-u[x]], R), assign='ideal');

Try (120, LeadingCoefficient (ideal, u), [[-2, -4, 4*v[y]-u[x]*u[y], v[x,x]-u[x]], [p, 1, v[x,x]]]);

# When no variable is given : it is the initial

Try (130, LeadingCoefficient (ideal), Initial (ideal));

#end test
