#test
# Tests the LeadingDerivative function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use

Try[testnoerror] (10, DifferentialRing (notation = diff, derivations = [x,y],
                        blocks = [[v,u],k1,k2,k3], parameters = [k1,k2,k3]),
			assign='R');

Try (20, LeadingDerivative (diff(u(x,y),x) + v(x,y)^2 - x + 2, R), diff(u(x,y),x));

Try (30, LeadingDerivative (k1*diff(u(x,y),x) + k2*k3*v(x,y)*u(x,y) - k2 + x - 4, R), diff(u(x,y),x));

Try (40, LeadingDerivative (k1*diff(u(x,y),x) + k2*k3*v(x,y)*u(x,y) = k2 + x - 4, R), diff(u(x,y),x));

# Applied to lists and sets

Try[testnoerror] (50, DifferentialRing (derivations=[x,y], blocks=[[v,u],p], parameters=[p]), assign='R');

Try (60, LeadingDerivative ([u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]], R), [u[y], u[x], v[y], v[x, x]]);

Try (70, LeadingDerivative ({u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]}, R), {u[y], u[x], v[y], v[x, x]});

# The unit ideal

Try (80, LeadingDerivative ([]), []);

# Other ideals

Try[testnoerror] (90, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+p, v[x,x]-u[x]], R), assign='ideal');

Try (100, LeadingDerivative (ideal), [[u[y], u[x], v[y], v[x, x]], [p, u, v[x, x]]]);

#end test
