#test
# Tests the LeadingRank function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use

Try[testnoerror] (10, DifferentialRing (notation = diff, derivations = [x,y],
                        blocks = [[v,u],k1,k2,k3], parameters = [k1,k2,k3]),
			assign='R');

Try (20, LeadingRank (diff(u(x,y),x) + v(x,y)^2 - x + 2, R), diff(u(x,y),x));

Try (30, LeadingRank (k1*diff(u(x,y),x)^3 + k2*k3*v(x,y)*u(x,y) - k2 + x - 4, R), diff(u(x,y),x)^3);

Try (40, LeadingRank (k1*diff(u(x,y),x)^3 + k2*k3*v(x,y)*u(x,y) = k2 + x - 4, R), diff(u(x,y),x)^3);

# Applied to lists and sets

Try[testnoerror] (50, DifferentialRing (derivations=[x,y], blocks=[[v,u],p], parameters=[p]), assign='R');

Try (60, LeadingRank ([u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]], R), [u[y]^2, u[x]^2, v[y], v[x, x]]);

Try (70, LeadingRank ({u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]}, R), {u[y]^2, u[x]^2, v[y], v[x, x]});

# Special ranks

Try (80, LeadingRank ([0, 34, x], R), [0, 1, x]);

# The unit ideal

Try (90, LeadingRank ([]), []);

# Other ideals

Try[testnoerror] (100, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+p, v[x,x]-u[x]], R), assign='ideal');

Try (110, LeadingRank (ideal), [[u[y]^2, u[x]^2, v[y], v[x, x]], [p, u, v[x, x]]]);

#end test
