#test
# Tests the behaviour of the package with respect to local variables,
# mixed global and exported local variables.

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

Try[testnoerror](10,
	proc () 
	    local u, R, koeffs, monoms; 
	    R := DifferentialRing (derivations = [], blocks = [u]);
	    koeffs, monoms := Coeffs (u, u, R);
	    return monoms [1];
	end proc,
	assign='func');

# func () returns an exported local, which is different from the global.

Try[testnoerror] (20, func(), assign='exported_u');

Try(30, evalb (u = exported_u), false);

Try(40, evalb (convert (u, 'string') = convert (exported_u, 'string')), true);

# Some unlikely identifiers

Try[testnoerror](50, DifferentialRing (derivations = [`x/a`], blocks = [u]), assign='R');

Try[testnoerror](60, RosenfeldGroebner ([u[`x/a`]^2-4*u], R), assign='ideal');

Try(70, Equations (ideal), [[u[`x/a`]^2-4*u], [u]]);

# Some fancy undocumented features
# convert (PDEtools:-TWSolutions, string) -> "TWSolutions"
# convert (3*PDEtools:-TWSolutions, string) -> "3*PDEtools:-TWSolutions"

 Try[testnoerror](80, y(x) = JacobiP(a,b,c,1/x^2), assign='`FB/mpldoc/label/eqnlbl0`');
 
# Try[testnoerror](90, PDEtools[dpolyform](`FB/mpldoc/label/eqnlbl0`,no_Fn), assign='result');

Try[testnoerror](80, DifferentialRing (derivations = [x], blocks = [PDEtools:-TWSolutions]), assign='R');

Try (90, LeadingDerivative (3*PDEtools:-TWSolutions, R), PDEtools:-TWSolutions);

#end test
