#test
# Tests the NormalForm function (basic uses)

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# The unit ideal

Try (10, NormalForm (u, []), 0);
Try (20, NormalForm ([u = 0, v], []), [0, 0]);
Try (30, NormalForm ({u, v}, []), {0});

# The zero ideal
Try[testnoerror] (40, DifferentialAlgebra0:-DifferentialRing
			(derivations = [x,y], blocks = [[v,u],p],
			parameters=[p]), assign='R');

Try[testnoerror] (50, RosenfeldGroebner ([], R), assign='ideal');

Try[testnoerror] (60, [u, u[x], u[y], u[x,x], u[x,y], u[y,y],
      u[x,x,x], u[x,x,y], u[x,y,y], u[y,y,y], v, v[x], v[y]], assign='L');

Try (70, NormalForm (L, ideal[1]), L);
Try (80, NormalForm (L, ideal), map (x -> [x], L));

# Basic use

Try[testnoerror] (90, [u, u[x], u[y], 2, 1/2*u[x]*u[y]/u, 1, 0, 0, 0, 0, v, v[x], 1/4*(u[x]*u[y]*u-u[x]*u[y]*p)/u], assign='A');
Try[testnoerror] (100, [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, v, v[x], v[y]], assign='B');

Try[testnoerror] (110, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+p, v[x,x]-u[x]], R), assign='ideal');

Try (120, NormalForm (L, ideal[1]), A);
Try (130, NormalForm (L, ideal[2]), B);
Try (140, NormalForm (L, ideal), zip ((x,y) -> [x,y], A, B));

# Some particular cases

Try (150, NormalForm ([u[x,x], u = 0, x, 1, 0], ideal[1]), [2, u, x, 1, 0]);

# NormalForm w.r.t. a ring

Try (160, NormalForm (u[x,x] = - p[x], R), u[x,x]);
Try (170, NormalForm ([u[x], u[y], 1], R), [u[x], u[y], 1]);

#end test
