#test
# Tests the NormalForm function w.r.t inverses and differentiation

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Tests that NF (NF (x) * NF (1/x)) = 1

Try[testnoerror] (10, DifferentialRing (derivations = [x,y], blocks = [[v,u]]),assign='R');

Try[testnoerror] (20, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+1, v[x,x]-u[x]], R)[1], assign='ideal');

Try (30, NormalForm (1/u[x]=1, ideal), 1/4*(u[x]-4*u)/u);

Try[testnoerror] (40, [u, u[x], u[y], u[x,x], u[x,y], u[y,y],
       v, v[x], v[y], v[x,x], v[x,y], v[y,y],
       v[x,x,x], v[x,x,y], v[x,y,y], v[y,y,y]], assign='L1');

Try[testnoerror] (50, map (x->1/x, L1), assign='L2');

Try[testnoerror] (60, NormalForm (L1, ideal), assign='R1');

Try[testnoerror] (70, NormalForm (L2, ideal), assign='R2');

Try[testnoerror] (80, [ seq (R1[i]*R2[i], i = 1 .. nops (L1)) ], assign='P');

Try[testnoerror] (90, NormalForm (P, ideal), assign='P');

Try (100, convert (P, set), {1});
 
# Tests that NF (Differentiate (NF (x))) = NF (Differentiate (x))

# R2 = NF (diff (L1))
Try[testnoerror] (110, Differentiate (L1, x, R), assign='R2');
Try[testnoerror] (120, NormalForm (R2, ideal), assign='R2');

# R1 = NF (diff (NF (L1)))
Try[testnoerror] (130, Differentiate (R1, x, R), assign='R1');
Try[testnoerror] (140, NormalForm (R1, ideal), assign='R1');

Try (150, R1, R2);

#end test
