#test
# Tests the NormalForm function with casesplit=true

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

Try[testnoerror] (10, DifferentialRing (derivations = [], blocks = [z,y,x]), assign='R');

Try[testnoerror] (20, RosenfeldGroebner
        ([(x-1)*(x+1)*(x^2-2), y^2 - x^3, z - y - x],
         attributes = [primitive,autoreduced], R)[1], assign='ideal');

# Regularization of zero

Try[testnoerror] (30, [x^4 - 3*x^2 + 2, y^2 - x^3, z - y - x], assign='eqns');

Try[testnoerror] (40, NormalForm (1/(z - y - x), ideal, casesplit=true), assign='result');

Try (50, map (nops, result) = [0, 1] and Equations (result [2,1]) = eqns, true);

# Splitting cases

Try[testnoerror] (60, 17*y*x^2+17*y*x-17*y-17*x-34, assign='nf1');
Try[testnoerror] (70, [x^3+x^2-2*x-2, y^2+x^2-2*x-2, z-y-x], assign='eqns1');
Try[testnoerror] (80, 17, assign='nf2');
Try[testnoerror] (90, [x - 1, y - 1, z - 2], assign='eqns2');
Try[testnoerror] (100, [x - 1, y + 1, z], assign='eqns3');

Try[testnoerror] (110, NormalForm (34/z, ideal, casesplit=true), assign='result');

Try (120, map (nops, result) = [2, 1] and
		result [1,1,1] = nf1 and
		Equations (result [1,1,2]) = eqns1 and
		result [1,2,1] = nf2 and
		Equations (result [1,2,2]) = eqns2 and
		Equations (result [2,1]) = eqns3, true);

# One branch is killed

Try[testnoerror] (130, (x^2+2*x)/2, assign='nf1');
Try[testnoerror] (140, [expand ((x+1)*(x^2-2)), y^2 + x^2 - 2*x -2, z - y - x], assign='eqns1');
Try[testnoerror] (150, [x-1, y^2-1, z-y-1], assign='eqns2');

Try[testnoerror] (160, NormalForm (1/(x-1), ideal, casesplit=true), assign='result');

Try (170, map (nops, result) = [1, 1] and
		result [1,1,1] = nf1 and
		Equations (result [1,1,2]) = eqns1 and
		Equations (result [2,1]) = eqns2, true);

#end test
