#test
# Tests the Notation function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# On a DRing
Try[testnoerror]
	(10, DifferentialRing (derivations = [x,y], blocks = [[v,u]]), assign='R');
Try (20, Notation (R), 'jet');

# On a regchain by RG
Try[testnoerror]
	(30, [u[x]^2-4*u = 0, u[x,y]*v[y]-u+1, v[x,x] = u[x]], assign='syst');

Try[testnoerror] (40, RosenfeldGroebner (syst, R), assign='ideal');
Try[testnoerror] (50, ideal[1], assign='ideal');
Try (60, Notation (ideal), 'jet');

Try[testnoerror] 
	(70, RosenfeldGroebner (syst, R, output='diff'), assign='ideal');
Try[testnoerror] (80, ideal[1], assign='ideal');
Try (90, Notation (ideal), 'diff');

# On a regchain by Pardi
Try[testnoerror] (100, Pardi (ideal, 
	ranking (derivations = [x,y], blocks = [[u,v]]),
	notation='Diff', prime=true), assign='jdeal');
Try (110, Notation (jdeal), 'Diff');

# On a regchain by PretendRegularDifferentialChain
Try[testnoerror] (120, PretendRegularDifferentialChain ([diff(u(x,y),x)^2-4*u(x,y)], R, input='diff', output='tjet'), assign='kdeal');
Try (130, Notation (kdeal), 'tjet');

#end test
