#test
# Tests some corners of the parser

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, DifferentialRing (derivations =[x,y], blocks = [u,p], parameters=[p]), assign='R');

# Derivatives of parameters must be simplified to zero
Try (20, Differentiate (p[x], R), 0);

Try (30, Differentiate (Diff(p,x), R, input=Diff), 0);

# Derivations commute
Try (40, LeadingDerivative (u[x,y]-u[y,x]-p, R), p);

# Special case

Try[testnoerror] (50, DifferentialRing(derivations = [y], blocks = [v,u[x], u[], a, e], parameters =[u[x], u[], a, e]), assign='RR');

Try (60, NormalForm (u[], RR), u[]);

Try[testnoerror] (70, DifferentialRing(notation = diff, derivations = [y], blocks = [v,u[x], u[], a, e], parameters =[u[x], u[], a, e]), assign='RR');

Try (80, NormalForm (u[], RR), u[]);

Try[testnoerror] (90, DifferentialRing (derivations =[x,y], blocks = [F]), assign='R');

Try[testerror] (100, RosenfeldGroebner ([G[x]*F[x] + F], R));

# The [] bug

Try[testnoerror] (110, op ([[y(_z3), 2*_F1(_z3)^2*_z3-2*_F1(_z3)^2*_z5+_F1(_z3)*v[1]*w[]-_F1(_z3)*_z1-4*_F1(_z3)*v[2]*w[1]*_z3+4*_F1(_z3)*w[1]*v[2]*_z5+2*_z3*w[1]^2*v[2]^2-2*w[1]^2*v[2]^2*_z5+_z2*v[1]*w[1]-v[1]*v[2]*w[]*w[1]], [_F1(_z3)]]), assign='sys');

Try[testnoerror] (120, [_z1, _z2, _z5, v[1], v[2], w[], w[1]], assign='pars');

Try[testnoerror] (130, DifferentialRing (derivations = [_z3], blocks = [[y, _F1], pars], parameters = pars, notation = diff), assign = 'R');

Try[testnoerror] (140, RosenfeldGroebner (sys, R, basefield = field (generators = pars)), assign = 'ideal');

Try[testnoerror] (150, Inequations (ideal));

#end test
