#test
# Tests the PowerSeriesSystem function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, DifferentialRing (derivations = [t], blocks = [y], notation=tjet), assign='R');

Try[testnoerror] (20, y[t]^3-4*y[t]*y[]*t+8*y[]^2, assign='F');

Try[testnoerror] (30, RosenfeldGroebner ([F], R), assign='ideal');

Try (40, [PowerSeriesSystem (ideal[1], [], check=all)], [[eval(diff(y(t),t),{t = 0})^3+8*y(0)^2 = 0], [3*eval(diff(y(t),t),{t = 0})^2 <> 0]]);

Try (50, [PowerSeriesSystem (ideal[1])], [[eval(diff(y(t),t),{t = 0})^3+8*y(0)^2 = 0], [3*eval(diff(y(t),t),{t = 0})^2 <> 0]]);

Try (60, [PowerSeriesSystem (ideal[1], check=equations)], [[eval(diff(y(t),t),{t = 0})^3+8*y(0)^2 = 0], []]);

Try (70, [PowerSeriesSystem (ideal[1], check=inequations)], [[], [3*eval(diff(y(t),t),{t = 0})^2 <> 0]]);

Try (80, [PowerSeriesSystem (ideal[1], check=nothing)], [[], []]);

Try (90, [PowerSeriesSystem (ideal[1], [y[]=c^3,y[t]=-2*c^2,t=0])], [[0 = 0], [12*c^4 <> 0]]);

Try (100, [PowerSeriesSystem (ideal[1], [y[]=c^3,y[t]=c^2,t=9*c/4])], [[0 = 0], [-6*c^4 <> 0]]);

# with the diff notation
#

Try[testnoerror] (110, DifferentialRing (notation = diff, derivations = [t], blocks = [y]), assign='R');

Try[testnoerror] (120, diff(y(t),t)^3-4*t*y(t)*diff(y(t),t)+8*y(t)^2, assign='F');

Try[testnoerror] (130, RosenfeldGroebner ([F], R), assign='ideal');

Try (140, [PowerSeriesSystem (ideal[1], [], check=all)], [[eval(diff(y(t),t),{t = 0})^3+8*y(0)^2 = 0], [3*eval(diff(y(t),t),{t = 0})^2 <> 0]]);

Try (150, [PowerSeriesSystem (ideal[1])], [[eval(diff(y(t),t),{t = 0})^3+8*y(0)^2 = 0], [3*eval(diff(y(t),t),{t = 0})^2 <> 0]]);

Try (160, [PowerSeriesSystem (ideal[1], check=equations)], [[eval(diff(y(t),t),{t = 0})^3+8*y(0)^2 = 0], []]);

Try (170, [PowerSeriesSystem (ideal[1], check=inequations)], [[], [3*eval(diff(y(t),t),{t = 0})^2 <> 0]]);

Try (180, [PowerSeriesSystem (ideal[1], check=nothing)], [[], []]);

Try (190, [PowerSeriesSystem (ideal[1], [y(t)=c^3,diff(y(t),t)=-2*c^2,t=0])], [[0 = 0], [12*c^4 <> 0]]);

Try (200, [PowerSeriesSystem (ideal[1], [y(t)=c^3,diff(y(t),t)=c^2,t=9*c/4])], [[0 = 0], [-6*c^4 <> 0]]);

#end test
