#test
# Tests the syntax of the PretendRegularDifferentialChain function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

Try[testnoerror]
        (10, DifferentialRing (derivations = [x,y], blocks = [[v,u]]), assign='R');

# Tests the syntax

Try[testnoerror]
	(20, PretendRegularDifferentialChain ([u[x]^2 - 4*u], R), assign='ideal');
Try (30, type (ideal, table), true);

Try[testnoerror]
        (40, PretendRegularDifferentialChain ([u[x]^2 - 4*u], R, pretend=true), assign='ideal');
Try (50, type (ideal, table), true);

Try[testnoerror]
        (60, PretendRegularDifferentialChain ([u[x]^2 - 4*u], R, pretend=false), assign='ideal');
Try (70, type (ideal, table), true);

# Deeper tests (pretend = true vs false)

Try[testnoerror] (80, 
	RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+1, v[x,x]-u[x]], R)[1],
	assign='ideal');

Try[testnoerror] (90, Equations (ideal), assign='eqns'):
Try[testnoerror] (100, PretendRegularDifferentialChain (eqns, R), assign='jdeal');
Try (110, evalb (Equations (jdeal) = eqns), true);

Try[testnoerror] (120, subsop (1 = u*eqns[1], eqns), assign='eqns2');
Try[testnoerror] (130, PretendRegularDifferentialChain (eqns2, R), assign='jdeal');
Try (140, evalb (Equations (jdeal) = eqns), false);

Try[testnoerror] (150, PretendRegularDifferentialChain (eqns, R, pretend=false), assign='jdeal');
Try (160, evalb (Equations (jdeal) = eqns), true);

# Algebraic relations among parameters

Try[testnoerror] (170, DifferentialRing (derivations = [t], blocks = [u,p,q,r], parameters = [p,q,r]), assign='R');

Try[testnoerror] (180, PretendRegularDifferentialChain ([q^2+1], R, pretend=false), assign='jdeal');

Try (190, Equations (jdeal, fullset=true), [q^2+1]);

# Algebraic setting

Try[testnoerror] (200, DifferentialRing (derivations = [], blocks = [u,p,q,r], parameters = [p,q,r]), assign='R');

Try[testnoerror] (210, PretendRegularDifferentialChain ([q^2+1], R, pretend=false), assign='jdeal');

Try (220, Equations (jdeal, fullset=true), [q^2+1]);

Try[testnoerror] (230, PretendRegularDifferentialChain ([q^2=-1], R, pretend=false), assign='jdeal');

Try (240, Equations (jdeal, fullset=true), [q^2+1]);

Try[testnoerror] (250, PretendRegularDifferentialChain ([(q^2+1)/r=0], R, pretend=false), assign='jdeal');

Try (260, Equations (jdeal, fullset=true), [q^2+1]);

#end test

