#test
# Tests the Ranking function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# On a DRing
Try[testnoerror]
	(10, DifferentialRing (derivations = [x,y], blocks = [[v,u]]), assign='R');
Try (20, Ranking (R),  ranking(derivations = [x, y], 
						blocks = [grlexA[v, u]]));

# On a regchain by RG
Try[testnoerror]
	(30, [u[x]^2-4*u = 0, u[x,y]*v[y]-u+1, v[x,x] = u[x]], assign='syst');

Try[testnoerror] (40, RosenfeldGroebner (syst, R), assign='ideal');
Try[testnoerror] (50, ideal[1], assign='ideal');
Try (60, Ranking (ideal), ranking(derivations = [x, y],                                                 blocks = [grlexA[v, u]]));

# On a regchain by Pardi (using many different rankings)

Try[testnoerror] (70, Pardi (ideal, 
	ranking (derivations = [x,y], blocks = [[u,v]]), prime=true), assign='jdeal');
Try (80, Ranking (jdeal), ranking(derivations = [x, y], 
					blocks = [grlexA[u, v]]));

Try (90, Ranking (Pardi (ideal, ranking (derivations = [x,y], blocks = [u,v]), prime=true)), ranking(derivations = [x, y], blocks = [grlexA[u], grlexA[v]]));

Try (100, Ranking (Pardi (ideal, ranking (derivations = [x,y], blocks = [lex[u],v]), prime=true)), ranking(derivations = [x, y], blocks = [lex[u], grlexA[v]]));

Try (110, Ranking (Pardi (ideal, ranking (derivations = [x,y], blocks = [degrevlexB[v,u]]), prime=true)), ranking (derivations = [x, y], blocks = [degrevlexB[v, u]]));

Try (120, Ranking (Pardi (ideal, ranking (derivations = [x,y], blocks = [degrevlexA[v,u]]), prime=true)), ranking (derivations = [x, y], blocks = [degrevlexA[v, u]]));

#end test
