#test
# Tests the ReducedForm function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, DifferentialRing (derivations = [x,y], blocks = [w,[v,u],t]), assign='R');

# Ring
Try (20, ReducedForm (u[x,x], R), u[x,x]);

Try[testnoerror] (30, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+1, v[x,x]-u[x]], R), assign='ideal');

# Zero and unit ideal
Try (40, ReducedForm (u[x,x], PretendRegularDifferentialChain([],R)), u[x,x]);
Try (50, ReducedForm (u[x,x], []), 0);

# Various tests
Try (60, ReducedForm (u[x,x], ideal), [2]);
Try (70, ReducedForm (u[x,x]/6, ideal), [1/3]);
Try (80, ReducedForm (u[x,y] = 0, ideal), [u[x, y]]);
Try (90, ReducedForm (v[y], ideal), [v[y]]);
Try (100, ReducedForm (4*u*v[y], ideal), [u[x]*u[y]*u - u[x]*u[y]]);
Try (110, ReducedForm (t*u*v[y], ideal), [1/4*u[x]*u[y]*u*t-1/4*u[x]*u[y]*t]);
Try (120, ReducedForm ((w+1)*(u*v[y]) = - u[x,y]*t, ideal[1]), 1/4*w*u[x]*u[y]*u-1/4*w*u[x]*u[y]+u[x,y]*t+1/4*u[x]*u[y]*u-1/4*u[x]*u[y]);

# Edgardo's example
Try[testnoerror] (130, DifferentialRing (derivations = [x], blocks = [[z,y]]), assign='R');
Try[testnoerror] (140, RosenfeldGroebner ([y[x,x]*(z[x,x]+z)], R), assign='ideal');
Try (150, ReducedForm (y[x,x]*z[x,x], ideal), [-y[x, x]*z, 0]);

#end test
