#test

# Tests the RewriteRules function
# Similar to Equations.

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# The unit ideal
Try (10, RewriteRules ([]), []);

# Parameters in order to test the fullset=true option
Try[testnoerror]
        (20, DifferentialRing (derivations = [t], blocks = [u,p], 
				parameters = [p]), assign='R');
Try[testnoerror]
	(30, RosenfeldGroebner ([u[t]^2 = p*u], 
				basefield = field (generators = [p]), R),
				assign='ideal');

Try (40, RewriteRules (ideal), [[u[t]^2 = p*u], [u = 0]]);

Try (50, RewriteRules (ideal, fullset=true), [[p[t] = 0, u[t]^2 = p*u], [p[t] = 0, u = 0]]);

# Selection criteria
Try[testnoerror]
        (60, DifferentialRing (derivations=[x,y], blocks=[[v,u]]),
				assign='R');
Try[testnoerror]
	(70, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+1, v[x,x]-u[x]], R),
				assign='ideal');

# The zero ideal

Try (80, RewriteRules (RosenfeldGroebner ([], R)[1]), []);

# The empty lists and sets

Try (90, RewriteRules ([], R), []);

Try (100, RewriteRules ({}, R), {});

# Double list
Try (110, RewriteRules (ideal), [[u[y]^2 = 2*u, u[x]^2 = 4*u, v[y] = -1/4*(-u[x]*u[y]*u+u[x]*u[y])/u, v[x,x] = u[x]]]);

# Simple list
Try[testnoerror] (120, ideal[1], assign='ideal');

Try (130, RewriteRules (ideal), [u[y]^2 = 2*u, u[x]^2 = 4*u, v[y] = -1/4*(-u[x]*u[y]*u+u[x]*u[y])/u, v[x,x] = u[x]]);

# Selection in a regchain
Try (140, RewriteRules (ideal, leader=v[x,x]), [v[x,x] = u[x]]);

# Selection in a list
# Non-numeric polynomials only

Try (150, RewriteRules (Equations (ideal), leader=v[x,x], R), [v[x,x] = u[x]]);

# Selection in a set
Try (160, RewriteRules ({u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y], v[x,x]-u[x]}, leader=v[x,x], R), {v[x,x] = u[x]});

Try (170, RewriteRules (Equations (ideal), leader<>v[x,x], R), [u[y]^2 = 2*u, u[x]^2 = 4*u, v[y] = -1/4*(-u[x]*u[y]*u+u[x]*u[y])/u]);

Try (180, RewriteRules (ideal, leader=u), []);

Try (190, RewriteRules (ideal, leader=derivative(u)), [u[y]^2 = 2*u, u[x]^2 = 4*u]);

Try (200,  RewriteRules (ideal, leader<>derivative(u)), [v[y] = -1/4*(-u[x]*u[y]*u+u[x]*u[y])/u, v[x,x] = u[x]]);

Try (210,  RewriteRules (ideal, leader=proper(u)), [u[y]^2=2*u, u[x]^2=4*u]);

Try (220, RewriteRules (ideal, leader>v[y]), [v[x,x] = u[x]]);

Try (230, RewriteRules (ideal, leader>=v[y]), [v[y] = -1/4*(-u[x]*u[y]*u+u[x]*u[y])/u, v[x,x] = u[x]]);

Try (240, RewriteRules (ideal, leader<v[y]), [u[y]^2 = 2*u, u[x]^2 = 4*u]);

Try (250, RewriteRules (ideal, leader<=v[y]), [u[y]^2 = 2*u, u[x]^2 = 4*u, v[y] = -1/4*(-u[x]*u[y]*u+u[x]*u[y])/u]);

Try (260,  RewriteRules ([u[x]^2-4*u], rank = u[x]^2, ideal), [u[x]^2=4*u]);

Try (270,  RewriteRules ([u[x]^2-4*u], rank = u[x], ideal), []);

Try (280, RewriteRules ([u[x]^2-4*u, v[x,x]], rank>=0, ideal), [u[x]^2 = 4*u, v[x,x] = 0]);

Try (290,  RewriteRules ([u[x]^2-4*u, v[x,x]], rank>=1, ideal), [u[x]^2 = 4*u, v[x,x] = 0]);

Try (300, RewriteRules ([u[x]^2-4*u, v[x,x]], rank<u, ideal), []);

Try (310, RewriteRules (ideal, order=1), [u[y]^2 = 2*u, u[x]^2 = 4*u, v[y] = -1/4*(-u[x]*u[y]*u+u[x]*u[y])/u]);

Try (320, RewriteRules (ideal, order>1), [v[x,x] = u[x]]);

Try (330, RewriteRules (ideal, order<1), []);

Try (340, RewriteRules (ideal, order<=1), [u[y]^2 = 2*u, u[x]^2 = 4*u, v[y] = -1/4*(-u[x]*u[y]*u+u[x]*u[y])/u]);

Try (350, RewriteRules
        ({u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]}, order=1, R),
	 {u[y]^2 = 2*u, u[x]^2 = 4*u, v[y] = -1/4*(-u[x]*u[y]*u+u[x]*u[y])/u});

Try (360, RewriteRules (ideal, order>=1), RewriteRules (ideal));

Try (370, RewriteRules (ideal, leader>v[y], output=diff),
		[diff(diff(v(x,y),x),x) = diff(u(x,y),x)]);

Try[testnoerror] (380, Equations (ideal, output=diff), assign='eqns');
Try (390, RewriteRules (eqns, leader=diff(v(x,y),x,x), R, input=diff), [v[x,x] = u[x]]);

Try (400, RewriteRules ([u[x,y]*v[y]-u+1, v[x,x]-u[x], u[x]^2-4*u], R),
		[u[x,y] = -(-u+1)/v[y], v[x,x] = u[x], u[x]^2 = 4*u]);

Try (410, RewriteRules (u[x,y]*v[y]-u+1, R), u[x,y] = -(-u+1)/v[y]);

Try (420, RewriteRules (u[x,y]*v[y]-u+1, order >= 3, R), NULL);

#end test
