#test
# Tests the syntax of the RosenfeldGroebner function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

Try[testnoerror]
	(10, DifferentialRing (derivations = [x,y], blocks = [[v,u]]), assign='R');


# Use of = signs in the equations
Try[testnoerror]
	(20, [u[x]^2-4*u = 0, u[x,y]*v[y]-u+1, v[x,x] = u[x]], assign='syst');


Try[testnoerror]
	(30, RosenfeldGroebner (syst, R), assign='ideal');

Try (40, type (ideal, list(table)) and nops (ideal) = 1, true);

# Use of = and <> in equations and inequations

Try[testnoerror] (50, RosenfeldGroebner ([u[x]^2-4*u = 0, u <> 0], R), assign='ideal');

Try (60, Equations (ideal), [[u[x]^2-4*u]]);

# The attributes parameter

Try[testnoerror]
        (70, RosenfeldGroebner (syst, attributes = [differential, primitive], R), assign='ideal');

Try (80, type (ideal, list(table)) and nops (ideal) = 1, true);


# Splittings
# Empty square brackets

Try[testnoerror]
	(90, RosenfeldGroebner ([u[x]^2 - 4*u[]], R), assign='ideal');

Try (100, type (ideal, list(table)) and nops (ideal) = 2, true);


# The inequations

Try[testnoerror]
        (110, RosenfeldGroebner ([u[x]^2 - 4*u[]], [u], R), assign='ideal');

Try (120, type (ideal, list(table)) and nops (ideal) = 1, true);

# The singsol='essential' parameter

Try[testnoerror]
        (130, RosenfeldGroebner ([u[x]^2 - 4*u[]], R, singsol='essential'), assign='ideal');

Try (140, type (ideal, list(table)) and nops (ideal) = 2, true);


# The basefield/generators parameter

Try[testnoerror]
        (150, RosenfeldGroebner ([u[x]^2 - 4*u[]], 
				 basefield = field (generators = [u,v]), R), 
				 assign='ideal');

Try (160, type (ideal, list(table)) and nops (ideal) = 0, true);

# Denominators in equations

Try[testnoerror]
        (170, RosenfeldGroebner ([(u[x]^2 - 4*u[])/u], R), assign='ideal');

Try (180, type (ideal, list(table)) and nops (ideal) = 1, true);

# An ideal instead of a DRing
# Not yet allowed.


# The basefield/relations parameter

Try[testnoerror] 
	(190, DifferentialRing (derivations = [t], blocks = [u, [s, c]]),
								assign='R');

Try[testnoerror]
	(200, RosenfeldGroebner ([s[t] - c, c[t] + s], R) [1],
							assign='sin_ideal');

Try[testnoerror]
	(210, RosenfeldGroebner ([u[t]^2 - s*u], 
		basefield = field (relations = sin_ideal), R), assign='ideal');

Try (220, type (ideal, list(table)) and nops (ideal) = 2, true);

# The singsol='essential' parameter, in cases where it does not apply

Try[testnoerror]
        (230, DifferentialRing (derivations = [t], blocks = [u,p], parameters = [p]), assign='R');

Try (240, nops (RosenfeldGroebner ([u[t]^2 - 4*u^3], singsol='essential', R)), 2);

# More basefield/relations parameter

Try[testnoerror]
        (250, DifferentialRing (derivations = [x], blocks = [grlexA[_F2,_F3,y], grlexA[_z1], grlexA[_F1[I,theta]]], notation = diff, parameters = [_z1, _F1[I,theta]]), assign='R');

Try[testnoerror]
	(260, RosenfeldGroebner ([y(x)-_F2(x), (_F3(x)*x^2-x)*diff(diff(_F2(x),x),x)+_F3(x)*x*diff(_F2(x),x)-diff(_F2(x),x)+_F3(x), diff(_F3(x),x)], [diff(_F2(x),x)], R, basefield = field (generators = [_z1, _F1[I,theta]], relations = PretendRegularDifferentialChain ([_z1^2+1], R))), assign = 'ideal');

#end test
