#test
# Tests the dimlb option of the RosenfeldGroebner function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use
Try[testnoerror] (10, DifferentialRing (derivations = [x,y], blocks = [u,v,a,b]), assign='R');

# Algebraic case, two equations
Try (20, nops (RosenfeldGroebner ([a*u+b, v], R)), 1);
Try (30, nops (RosenfeldGroebner ([a*u+b, v], R, dimlb=nocase)), 2);
Try (40, nops (RosenfeldGroebner ([a*u+b, v], R, dimlb=safecase)), 1);
Try (50, nops (RosenfeldGroebner ([a*u+b, v], R, dimlb=odecase)), 1);
Try (60, nops (RosenfeldGroebner ([a*u+b, v], R, dimlb=pdecase)), 1);

# Non algebraic case, one equation
Try (70, nops (RosenfeldGroebner ([a*u[x,y]+b], R)), 1);
Try (80, nops (RosenfeldGroebner ([a*u[x,y]+b], R, dimlb=nocase)), 2);
Try (90, nops (RosenfeldGroebner ([a*u[x,y]+b], R, dimlb=safecase)), 1);
Try (100, nops (RosenfeldGroebner ([a*u[x,y]+b], R, dimlb=odecase)), 1);
Try (110, nops (RosenfeldGroebner ([a*u[x,y]+b], R, dimlb=pdecase)), 1);

# ODE case, two equations
Try (120, nops (RosenfeldGroebner ([a*u[x]+b, v[x]], R)), 2);
Try (130, nops (RosenfeldGroebner ([a*u[x]+b, v[x]], R, dimlb=nocase)), 2);
Try (140, nops (RosenfeldGroebner ([a*u[x]+b, v[x]], R, dimlb=safecase)), 2);
Try (150, nops (RosenfeldGroebner ([a*u[x]+b, v[x]], R, dimlb=odecase)), 1);
Try (160, nops (RosenfeldGroebner ([a*u[x]+b, v[x]], R, dimlb=pdecase)), 1);

# PDE case, two equations
Try (170, nops (RosenfeldGroebner ([a*u[x]+b, v[y]], R)), 2);
Try (180, nops (RosenfeldGroebner ([a*u[x]+b, v[y]], R, dimlb=nocase)), 2);
Try (190, nops (RosenfeldGroebner ([a*u[x]+b, v[y]], R, dimlb=safecase)), 2);
Try (200, nops (RosenfeldGroebner ([a*u[x]+b, v[y]], R, dimlb=odecase)), 2);
Try (210, nops (RosenfeldGroebner ([a*u[x]+b, v[y]], R, dimlb=pdecase)), 1);

#end test
