#test
# Tests the syntax of the RosenfeldGroebner function with the Diff syntax

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

Try[testnoerror]
	(10, DifferentialRing (derivations = [x,y], blocks = [[v,u]],
				notation = Diff), assign='R');


# Use of = signs in the equations
Try[testnoerror]
	(20, [Diff(u(x,y),x)^2-4*u(x,y) = 0, 
	      Diff(u(x,y),x,y)*Diff(v(x,y),y)-u(x,y)+1,
	      Diff(Diff(v(x,y),x),x) = Diff(u(x,y),x)], assign='syst');


Try[testnoerror]
	(30, RosenfeldGroebner (syst, R), assign='ideal');

Try (40, type (ideal, list(table)) and nops (ideal) = 1, true);


# The attributes parameter

Try[testnoerror]
        (50, RosenfeldGroebner (syst, attributes = [differential, primitive], R), assign='ideal');

Try (60, type (ideal, list(table)) and nops (ideal) = 1, true);


# Splittings

Try[testnoerror]
	(70, RosenfeldGroebner ([Diff(u(x,y),x)^2 - 4*u(x,y)], R), 
							assign='ideal');

Try (80, type (ideal, list(table)) and nops (ideal) = 2, true);


# The inequations

Try[testnoerror]
        (90, RosenfeldGroebner ([Diff(u(x,y),x)^2 - 4*u(x,y)], 
			[u(x,y)], R), assign='ideal');

Try (100, type (ideal, list(table)) and nops (ideal) = 1, true);

# The singsol=essential parameter

Try[testnoerror] (110, RosenfeldGroebner ([Diff(u(x,y),x)^2 - 4*u(x,y)], R, singsol='essential'), assign='ideal');

Try (120, type (ideal, list(table)) and nops (ideal) = 2, true);

# The basefield parameter

Try[testnoerror]
        (130, RosenfeldGroebner ([Diff(u(x,y),x)^2 - 4*u(x,y)], 
			basefield = field (generators = [v,u]), R), 
			assign='ideal');

Try (140, type (ideal, list(table)) and nops (ideal) = 0, true);


# Denominators in equations

Try[testnoerror]
        (150, RosenfeldGroebner ([(Diff(u(x,y),x)^2 - 4*u(x,y))/u(x,y)], R), 
			assign='ideal');

Try (160, type (ideal, list(table)) and nops (ideal) = 1, true);


# An ideal instead of a DRing
# Not yet allowed.

# The basefield/relations parameter

Try[testnoerror] (170, DifferentialRing (derivations = [t], blocks = [u, [s, c]], notation = Diff), assign='R');

Try[testnoerror] (180, RosenfeldGroebner ([Diff(s(t),t) - c(t), Diff(c(t),t) + s(t)], R) [1], assign='sin_ideal');

Try[testnoerror] (190, RosenfeldGroebner ([Diff(u(t),t)^2 - s(t)*u(t)], basefield = field (relations = sin_ideal), R), assign='ideal');

Try (200, type (ideal, list(table)) and nops (ideal) = 2, true);

#end test
