#test
# Tests the Separant function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use

Try[testnoerror] (10, DifferentialRing (notation = diff, derivations = [x,y],
                        blocks = [[v,u],k1,k2,k3], parameters = [k1,k2,k3]),
			assign='R');

Try (20, Separant 
	(diff(u(x,y),x) + k1*v(x,y)^2 - x + 2, diff(u(x,y),x), R), 1);

# Separant w.r.t. some variable

Try (30, Separant 
	(diff(u(x,y),x) + k1*v(x,y)^2 - x + 2, diff(u(x,y),y,x), R), 0);

Try (40, Separant 
	(diff(u(x,y),x) + k1*v(x,y)^2 = x + 2, v(x,y), R), 2*k1*v(x,y));

Try (50, Separant (diff(u(x,y),x) + k1*v(x,y)^2 - x + 2, x, R), -1);

Try (60, Separant (diff(u(x,y),x) + k1*v(x,y)^2 - x + 2, k1, R), v(x,y)^2);

# Applied to lists and sets

Try[testnoerror] (70, DifferentialRing (derivations=[x,y], blocks=[[v,u],p], parameters=[p]), assign='R');

Try (80, Separant ([u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]], R), [2*u[y], 2*u[x], 4*u, 1]);

Try (90, Separant ({u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]}, R), {2*u[y], 2*u[x], 4*u, 1});

# Separant w.r.t. a variable

Try (100, Separant ([u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]], u[x], R), [0, 2*u[x], -u[y]*u+u[y]*p, -1]);

Try (110, Separant ({u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]}, u[x], R), {0, 2*u[x], -u[y]*u+u[y]*p, -1});

# The unit ideal

Try (120, Separant ([]), []);
Try (130, Separant ([], u[x]), []);

# Other ideals

Try[testnoerror] (140, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+p, v[x,x]-u[x]], R), assign='ideal');

Try (150, Separant (ideal), [[2*u[y], 2*u[x], 4*u, 1], [1, 1, 1]]);

Try (160, Separant (ideal, u), [[-2, -4, 4*v[y]-u[x]*u[y], 0], [0, 1, 0]]);

#end test
