#test
# Tests the Tail function

with (TestTools):

##read "DifferentialAlgebra0.mpl";
with (DifferentialAlgebra0):

# Basic use

Try[testnoerror] (10, DifferentialRing (notation = diff, derivations = [x,y],
                        blocks = [[v,u],k1,k2,k3], parameters = [k1,k2,k3]),
			assign='R');

Try (20, Tail (diff(u(x,y),x) + v(x,y)^2 - x + 2, R), v(x,y)^2 - x + 2);

Try (30, Tail (k1*diff(u(x,y),x) + k2*k3*v(x,y)*u(x,y) - k2 + x = 4, R), k2*k3*v(x,y)*u(x,y) - k2 + x - 4);

# Applied to lists and sets

Try[testnoerror] (40, DifferentialRing (derivations=[x,y], blocks=[[v,u],p], parameters=[p]), assign='R');

Try (50, Tail ([u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]], R), [-2*u, -4*u, -u[x]*u[y]*u+u[x]*u[y]*p, -u[x]]);

Try (60, Tail ({u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y]*p, v[x,x]-u[x]}, R), {-2*u, -4*u, -u[x]*u[y]*u+u[x]*u[y]*p, -u[x]});

# The unit ideal

Try (70, Tail ([]), []);

# Other ideals

Try[testnoerror] (80, RosenfeldGroebner ([u[x]^2-4*u, u[x,y]*v[y]-u+p, v[x,x]-u[x]], R), assign='ideal');

Try (90, Tail (ideal), [[-2*u, -4*u, -u[x]*u[y]*u+u[x]*u[y]*p, -u[x]], [0, 0, 0]]);

#end test
