read "Kaehler.mpl";

R := DifferentialRing (derivations = [x,y], blocks = [[v,u]]);
syst := [ u[x]^2-4*u, u[x,y]*v[y]-u+1, v[x,x]-u[x] ];
ideal := RosenfeldGroebner (syst, R);
dR := DifferentialRing (derivations = [x,y], blocks = [[d(v),d(u)],[v,u]]);
dsyst := map (differential, syst, dR, v -> d(v));
dideal := RosenfeldGroebner ([op(dsyst),op(syst)], dR);

M, indcs := Matrix (0, 1), []:
M, indcs := enlargeMatrix (M, indcs, 1, ideal[1], decomposeNF):
# M, indcs := enlargeMatrix (M, indcs, v, ideal[1], decomposeNF);
# M, indcs := enlargeMatrix (M, indcs, v[x], ideal[1], decomposeNF);
# M, indcs := enlargeMatrix (M, indcs, v[y], ideal[1], decomposeNF);
# M, indcs := enlargeMatrix (M, indcs, v[y,y], ideal[1], decomposeNF);
M, indcs := enlargeMatrix (M, indcs, v[y]^2, ideal[1], decomposeNF):
# M, indcs := enlargeMatrix (M, indcs, v[y]*v[y,y], ideal[1], decomposeNF);
M, indcs := enlargeMatrix (M, indcs, v[y,y]^2, ideal[1], decomposeNF):
# M, indcs := enlargeMatrix (M, indcs, v[y]^3, ideal[1], decomposeNF);
# M, indcs := enlargeMatrix (M, indcs, v[y]^2*v[y,y], ideal[1], decomposeNF);
# M, indcs := enlargeMatrix (M, indcs, v[y]*v[y,y]^2, ideal[1], decomposeNF);
# M, indcs := enlargeMatrix (M, indcs, v[y,y]^3, ideal[1], decomposeNF);
# M, indcs := enlargeMatrix (M, indcs, v[y]^4, ideal[1], decomposeNF);
# M, indcs := enlargeMatrix (M, indcs, v[y,y]*v[y]^3, ideal[1], decomposeNF);
# M, indcs := enlargeMatrix (M, indcs, v[y,y]^2*v[y]^2, ideal[1], decomposeNF);
# M, indcs := enlargeMatrix (M, indcs, v[y,y]^3*v[y], ideal[1], decomposeNF);
M, indcs := enlargeMatrix (M, indcs, v[y,y]^4, ideal[1], decomposeNF);
pivote (M);

dM, dindcs := Matrix (0, 1), []:
dM, dindcs := enlargeMatrix (dM, dindcs, d(v), dideal[1], decomposeDNF):
dM, dindcs := enlargeMatrix (dM, dindcs, d(v)[y], dideal[1], decomposeDNF):
dM, dindcs := enlargeMatrix (dM, dindcs, d(v)[y,y], dideal[1], decomposeDNF);
pivote (dM);


