read "/home/calforme/boulier/bmi-install/maple/DifferentialAlgebra.mpl";
with (DifferentialAlgebra);
n := 2;
fg := proc (a,b) 
    if a < b then g[a,b] else g[b,a] end if 
end proc:
fGamma := proc (a,b,c) 
    if a < b then Gamma[[a,b],c] else Gamma[[b,a],c] end if 
end proc:
formule := proc (i,j,k) 
    local p; 
    add (-2*fg(p,k)*fGamma(i,j,p), p = 1..n) = 
         fg(i,j)[x[k]] - fg(j,k)[x[i]] - fg(i,k)[x[j]] 
end proc:
L := NULL:
for i from 1 to n do
    for j from 1 to n do
        for k from 1 to n do
            L := L, formule(i,j,k)
        end do
    end do
end do:
L := {L}:
L := convert (L, list);
LGamma := select(x->has(x,Gamma),indets(L)):
LGamma := convert(LGamma,list);
Lx := [seq(x[i],i=1..n)];
Lg := [seq(seq(g[i,j],j=i..n),i=1..n)];
R := DifferentialRing(derivations=Lx, blocks=[LGamma,Lg]);
ideal := RosenfeldGroebner(convert(L,list),R,algindep=Lg);
ideal := ideal [1];
RewriteRules (ideal);
# Pardi (ideal, ordering (derivations=Lx,blocks=[Lg,LGamma]));

read "Kaehler.mpl";

dLg := map(v->d(v),Lg);
dLGamma := map(v->d(v),LGamma);

dR := DifferentialRing (derivations = Lx, blocks = [dLGamma,dLg,LGamma,Lg]);
dL := map (differential, Equations (ideal), dR, v -> d(v));
dideal := RosenfeldGroebner ([op(dL),op(Equations(ideal))], algindep=Lg, dR);
dideal := dideal [1];
dkdeal := PretendRegchain ([op(dL),op(Equations(ideal))], pretend=false, dR);

Equations (dideal) - Equations (dkdeal);

# djdeal := Pardi (dkdeal, ordering (derivations = Lx, blocks = [dLg,dLGamma,LGamma,Lg]));


