"""
TESTS:
    sage: from sage.libs.blad.DifferentialAlgebra import DifferentialRing
    sage: from sage.libs.blad.DifferentialAlgebra import RegularDifferentialChain
    sage: x,a,b = var('x,a,b')
    sage: y = function ('y')
    sage: R = DifferentialRing (derivations = [x], blocks = [y,[a,b]], parameters = [a,b])
    sage: C = RegularDifferentialChain ([diff(y(x),x)^2-a*y(x)], R)
    sage: C
    regular_differential_chain
    sage: C.equations ()
    [-a*y(x) + D[0](y)(x)^2]
    sage: C.equations (solved = true)
    [D[0](y)(x)^2 == a*y(x)]
"""

"""
TESTS:
    sage: from sage.libs.blad.DifferentialAlgebra import DifferentialRing
    sage: from sage.libs.blad.DifferentialAlgebra import RegularDifferentialChain
    sage: x,y = var ('x,y')
    sage: u,v = function ('u,v')
    sage: R = DifferentialRing (derivations = [x,y], blocks = [u,v])
    sage: eq1 = diff(u(x,y),x) == v(x,y)
    sage: eq2 = diff(u(x,y),y) == 0
    sage: eq3 = diff(v(x,y),y) == 0
    sage: C = RegularDifferentialChain ([eq1,eq2,eq3], R)
    sage: C.equations (solved=True)
    [D[1](v)(x, y) == 0, D[1](u)(x, y) == 0, D[0](u)(x, y) == v(x, y)]
    sage: leader,rank,order = var ('leader,rank,order')
    sage: derivative,proper = function ('derivative,proper')
    sage: C.equations (selection = order == 0)
    []
    sage: C.equations (selection = order != 0)
    [D[1](v)(x, y), D[1](u)(x, y), -v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = order >= 0)
    [D[1](v)(x, y), D[1](u)(x, y), -v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = order >  0)
    [D[1](v)(x, y), D[1](u)(x, y), -v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = order <= 0)
    []
    sage: C.equations (selection = order <  0)
    []
    sage: C.equations (selection = leader == diff (u(x,y),x))
    [-v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = leader != diff (u(x,y),x))
    [D[1](v)(x, y), D[1](u)(x, y)]
    sage: C.equations (selection = leader >= diff (u(x,y),x))
    [-v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = leader >  diff (u(x,y),x))
    []
    sage: C.equations (selection = leader <= diff (u(x,y),x))
    [D[1](v)(x, y), D[1](u)(x, y), -v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = leader <  diff (u(x,y),x))
    [D[1](v)(x, y), D[1](u)(x, y)]
    sage: C.equations (selection = leader == derivative (diff (u(x,y),x)))
    [-v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = leader != derivative (diff (u(x,y),x)))
    [D[1](v)(x, y), D[1](u)(x, y)]
    sage: C.equations (selection = rank > 0)
    [D[1](v)(x, y), D[1](u)(x, y), -v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = rank > 1)
    [D[1](v)(x, y), D[1](u)(x, y), -v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = rank == diff (u(x,y),x)^2)
    []
    sage: C.equations (selection = rank != diff (u(x,y),x)^2)
    [D[1](v)(x, y), D[1](u)(x, y), -v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = rank >= diff (u(x,y),x)^2)
    []
    sage: C.equations (selection = rank >  diff (u(x,y),x)^2)
    []
    sage: C.equations (selection = rank <= diff (u(x,y),x)^2)
    [D[1](v)(x, y), D[1](u)(x, y), -v(x, y) + D[0](u)(x, y)]
    sage: C.equations (selection = rank <  diff (u(x,y),x)^2)
    [D[1](v)(x, y), D[1](u)(x, y), -v(x, y) + D[0](u)(x, y)]
"""

"""
TESTS:
    sage: from sage.libs.blad.DifferentialAlgebra import DifferentialRing
    sage: from sage.libs.blad.DifferentialAlgebra import RegularDifferentialChain
    sage: x,y = var ('x,y')
    sage: u,v = function ('u,v')
    sage: R = DifferentialRing (derivations = [x,y], blocks = [u,v])
    sage: C = RegularDifferentialChain ([], R)
    sage: C.equations ()
    []
"""
