"""
TESTS:
    sage: x = var('x')
    sage: y = function ('y')
    sage: from sage.libs.blad.DifferentialAlgebra import DifferentialRing, RegularDifferentialChain
    sage: R = DifferentialRing (derivations = [x], blocks = [y])
    sage: L = R.RosenfeldGroebner ([diff(y(x),x)^2-4*y(x)], singsol = 'essential')
    sage: L
    [regular_differential_chain, regular_differential_chain]
    sage: L[0].equations ()
    [D[0](y)(x)^2 - 4*y(x)]
    sage: L[1].equations ()
    [y(x)]
    sage: L[0].equations (solved = true)
    [D[0](y)(x)^2 == 4*y(x)]
    sage: M = R.RosenfeldGroebner ([diff(y(x),x)^2-4*y(x)^3], singsol = 'essential')
    sage: M
    [regular_differential_chain]
    sage: M[0].equations ()
    [-4*y(x)^3 + D[0](y)(x)^2]
"""

"""
TESTS:
    sage: from sage.libs.blad.DifferentialAlgebra import DifferentialRing
    sage: x,y = var('x,y')
    sage: u,v = function('u,v')
    sage: R = DifferentialRing (derivations = [x,y], blocks = [[v,u]])
    sage: eq1 = diff(u(x,y),x)^2 - 4*u(x,y) == 0
    sage: eq2 = diff(diff(u(x,y),x),y) * diff(v(x,y),y) - u(x,y) + 1 == 0
    sage: eq3 = diff(diff(v(x,y),x),x) - diff(u(x,y),x) == 0
    sage: L = R.RosenfeldGroebner ([eq1, eq2, eq3])
    sage: L
    [regular_differential_chain]
    sage: L[0].equations (solved=true)
    [D[1](u)(x, y)^2 == 2*u(x, y), D[0](u)(x, y)^2 == 4*u(x, y), D[1](v)(x, y) == 1/4*(u(x, y)*D[0](u)(x, y)*D[1](u)(x, y) - D[0](u)(x, y)*D[1](u)(x, y))/u(x, y), D[0, 0](v)(x, y) == D[0](u)(x, y)]
"""
