# This sed file is used to transform some bmi header files
#   into bmi_c.pxd which is a cython header file

# Leading backslashes after the i-command are needed for OS X Lion

1i\
# This file automatically generated from some bmi header files\
\
cdef extern from "bmi.h":\
\    ctypedef int bool\
\    ctypedef long ba0_int_p
/^struct/{
    s/.*/    &:/ 
# print the struct line
    p
# skip the opening curly brace
    n
    n
    :loop-struct
# apply to any struct field line
    s/^\( .*\);/    \1/
    t next-struct
    b end-loop-struct
    :next-struct
    s/struct //
    s/enum //
    p
    n
    b loop-struct
    :end-loop-struct
    d
}
/^enum/{
    s/.*/    &:/
    p
    n
    n
    :loop-enum
    s/^\( [^,]*\)[,]*/    \1/
    t next-enum
    b end-loop-enum
    :next-enum
    p
    n
    b loop-enum
    :end-loop-enum
    d
}
/^typedef/{
    s/typedef/ctypedef/
    :loop-typedef
    s/struct //
    s/enum //
    s/M_DECL //
    s/^/    /
    t next-typedef
    :next-typedef
    s/;//
    t end-loop-typedef
    p
    n
    b loop-typedef
    :end-loop-typedef
    p
}
/^extern/{
    s/extern /    /
    t next-extern-1
    :next-extern-1
    s/;//
    t endloop-extern
    p
    n
    :loop-extern
    s/struct //
    s/enum //
    s/^/  /
    t next-extern-2
    :next-extern-2
    s/);/)/
    t endloop-extern
    p
    n
    b loop-extern
    :endloop-extern
    s/void)/)/
    p
}
d
