#!/bin/bash

# This one creates the source distribution in dist
python3 -m build --sdist

# This one calls build-wheels.sh via docker to build the wheels
sudo systemctl start docker

DOCKER_IMAGE=quay.io/pypa/manylinux2014_x86_64
PLAT=manylinux2014_x86_64

docker pull ${DOCKER_IMAGE}

# docker container run -it --rm -v $(pwd):/io ${DOCKER_IMAGE} bash

# -i   : interactive
# -t   : create a tty
# --rm : clean the container at exit
# the current directory is mounted as /io

docker container run -t --rm -e PLAT=${PLAT} -v $(pwd):/io ${DOCKER_IMAGE} /io/build-wheels.sh

sudo chown -R $USER:$USER build dist tests
